/*


???

*/

/****************************************************************************
    This file is part of the FreeWRL/FreeX3D Distribution.

    Copyright 2009 CRC Canada. (http://www.crc.gc.ca)

    FreeWRL/FreeX3D is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FreeWRL/FreeX3D is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FreeWRL/FreeX3D.  If not, see <http://www.gnu.org/licenses/>.
****************************************************************************/



#include <config.h>
#ifdef JAVASCRIPT_SM
#if defined(JS_SMCPP)
#undef DEBUG
//#define DEBUG 1 //challenge it with lots of ASSERTS, just for cleaning up code correctness, not production
# include <jsapi.h> /* JS compiler */
# include <jsdbgapi.h> /* JS debugger */
//#if !(defined(JAVASCRIPT_STUB) || defined(JAVASCRIPT_DUK))
#define JS_VERSION 187
//#define JS_THREADSAFE 1 //by default in 186+

#define STRING_SIZE 256
#define uintN unsigned
#define intN int
#define jsint int32_t
#define jsuint uint32_t
#define int32 int32_t
#define jsdouble double

#define JS_FinalizeStub NULL
#ifndef IBOOL
typedef int IBOOL;
#endif
typedef IBOOL _Bool;



extern "C" {
#include <system.h>
//#if !(defined(JAVASCRIPT_STUB) || defined(JAVASCRIPT_DUK))

//#include <system_threads.h>
#include <display.h>
#include <internal.h>

//#include <libFreeWRL.h>
#include "../scenegraph/LinearAlgebra.h"
#include "../scenegraph/quaternion.h"

//#include "../vrml_parser/Structs.h"
//#include "../main/headers.h"
//#include "../vrml_parser/CParseGeneral.h"
//#include "../main/Snapshot.h"
//#include "../scenegraph/Collision.h"
//#include "../scenegraph/quaternion.h"
//#include "../scenegraph/Viewer.h"
//#include "../input/SensInterps.h"
//#include "../x3d_parser/Bindable.h"

#include "JScript.h"
#include "CScripts.h"
#include "jsNative.h"

#include "JScript.h"

} //extern "C"

#include "jsUtils_sm.h"
#include "jsVRMLClasses_sm.h"

/********************************************************/
/*							*/
/* Third part - MF classes				*/
/*							*/
/********************************************************/

/* remove any private data from this datatype, and let the garbage collector handle the object */

void
#if JS_VERSION < 186
JS_MY_Finalize(JSContext *cx, JSObject *obj){
#else
JS_MY_Finalize(JSFreeOp *fop, JSObject *obj){
//JSContext *cx = NULL;
#endif

	void *ptr;
	//#ifdef JSVRMLCLASSESVERBOSE
	//printf ("finalizing %p\n",obj);
	//printJSNodeType(cx,obj);
	//#endif

	//REMOVE_ROOT(cx,obj)

	//if ((ptr = (void *)JS_GetPrivateFw(cx, obj)) != NULL) {
		ptr = (void*)JS_GetPrivate(obj);
		if (ptr) {
			if (SM_method() == 0)
				FREE_IF_NZ(ptr);
			if (SM_method() == 2) {
				//AnyNativeNew mallocs ptr, v and elsewhere mf.p is malloced
				AnyNative* any = (AnyNative*)ptr;
				if (any->gc) {
					if (any->type % 2 == 1) //is it MF
						FREE_IF_NZ(any->v->mffloat.p);
					FREE_IF_NZ(any->v);
				}
				//printf("finalize anygc = %d\n", any->gc);
				FREE_IF_NZ(ptr);
			}
		}
		//JS_SetPrivateFw(cx,obj,NULL);
		//FREE_IF_NZ(ptr);
		
	//}

	#ifdef JSVRMLCLASSESVERBOSE
	} else {
		printf ("Finalize - no private data!\n");
	}
	#endif

}

// MFColor
JSBool
MFColorToString(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_THIS_OBJECT(cx,vp);
        jsval *argv = JS_ARGV(cx,vp);
	jsval rval;

	UNUSED(argc);
	UNUSED(argv);
	if (!doMFToString(cx, obj, "MFColor", &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx,vp,rval);
	return JS_TRUE;

}

JSBool
MFColorAssign(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_THIS_OBJECT(cx,vp);
        jsval *argv = JS_ARGV(cx,vp);
	jsval rval;
	if (!_standardMFAssign (cx, obj, argc, argv, &rval, &MFColorClass,FIELDTYPE_SFColor)) { return JS_FALSE; }
	JS_SET_RVAL(cx,vp,rval);
	return JS_TRUE;

}

JSBool
MFColorConstr(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_NewObject(cx,&MFColorClass,NULL,NULL);
        jsval *argv = JS_ARGV(cx,vp);
        jsval rval = OBJECT_TO_JSVAL(obj);
        if (!MFColorConstrInternals(cx,obj,argc,argv,&rval)) { return JS_FALSE; }
        JS_SET_RVAL(cx,vp,rval);
        return JS_TRUE;
}
JSBool MFColorConstrInternals(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval) {

	JSObject *_arrayObj;
	int isArray;
	JSObject *_obj;
	unsigned int i;
	union anyVrml *anyv;
	
	ADD_ROOT(cx,obj)

	isArray = FALSE;
	if(argc == 1 && argv){
		//could it be new MFxxx( [A,B] ) javscript array, as used by Carlson aka Carlson Array
		// tests/JohnCarlson/Arc1A.x3d
		if (!JS_ValueToObject(cx, argv[0], &_arrayObj)) {
			printf( "JS_ValueToObject failed in MFVec3fConstr.\n");
			return JS_FALSE;
		}

		if(JS_IsArrayObject(cx, _arrayObj)){
			jsuint lengthp;
			jsval vp;
			//printf("its an array\n");
			isArray = TRUE;
			JS_GetArrayLength(cx,_arrayObj, &lengthp);
			argc = lengthp;
		}
	}

	if(SM_method() == 2){
		AnyNative *any;
		int newsize;
		if((any = (AnyNative*)AnyNativeNew(FIELDTYPE_MFColor,NULL,NULL)) == NULL){
			printf( "AnyfNativeNew failed in MFColorConstr.\n");
			return JS_FALSE;
		}
		if (!JS_SetPrivateFw(cx, obj, any)) {
			printf( "JS_SetPrivate failed in MFColorConstr.\n");
			return JS_FALSE;
		}
		anyv = any->v;
		newsize = sizeof(struct SFColor)*upper_power_of_two(argc);
		if(argc > 0){
			anyv->mfcolor.p = MALLOC(struct SFColor*,newsize);
			memset(anyv->mfcolor.p,0,newsize);
		}

	}else{
		DEFINE_LENGTH(cx,obj,argc)
	}
	if (!argv) {
		return JS_TRUE;
	}

	#ifdef JSVRMLCLASSESVERBOSE
		printf("MFColorConstr: obj = %p, %u args\n",
			   obj, argc);
	#endif

	for (i = 0; i < argc; i++) {
		jsval vp;
		if(isArray){
			JS_GetElement(cx, _arrayObj, i, &vp);

		}else{
			vp = argv[i];
		}
		if (!JS_ValueToObject(cx, vp, &_obj)) {
			printf(
					"JS_ValueToObject failed in MFColorConstr.\n");
			return JS_FALSE;
		}

		CHECK_CLASS(cx,_obj,NULL,__FUNCTION__,SFColorClass)
		if(SM_method()==2){
			AnyNative *any2;
			if((any2 = (AnyNative *)JS_GetPrivateFw(cx,_obj)) != NULL){
				//2018 I think as long as its 3+ contiguous floats, we can use it as a color, 
				// but in future internal types might change
				if(any2->type == FIELDTYPE_SFColor || any2->type == FIELDTYPE_SFVec3f || any2->type == FIELDTYPE_SFColorRGBA){
					shallow_copy_field(FIELDTYPE_SFColor,any2->v,(union anyVrml*)&anyv->mfcolor.p[i]);
					anyv->mfcolor.n = i+1;
				}
			}
			// else for now we'll leave zeros
		}else{
			if (!JS_DefineElement(cx, obj, (jsint) i, vp, JS_GET_PROPERTY_STUB, JS_SET_PROPERTY_CHECK, JSPROP_ENUMERATE)) {
				printf( "JS_DefineElement failed for arg %u in MFColorConstr.\n", i);
				return JS_FALSE;
			}
		}
	}
	*rval = OBJECT_TO_JSVAL(obj);
	return JS_TRUE;
}

JSBool

MFColorAddProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid,  JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();
	jsval *vp = hvp.address();

	return doMFAddProperty(cx, obj, id, vp,"MFColorAddProperty");
}

JSBool
MFColorGetProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid,  JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();
	jsval *vp = hvp.address();

	return _standardMFGetProperty(cx, obj, id, vp,
			"_FreeWRL_Internal = new SFColor()", FIELDTYPE_MFColor);
}

JSBool
MFColorSetProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JSBool strict, JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();
	jsval *vp = hvp.address();

	return doMFSetProperty(cx, obj, id, vp,FIELDTYPE_MFColor);
}

// MFColorRGBA
JSBool
MFColorRGBAToString(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;

	UNUSED(argc);
	UNUSED(argv);
	if (!doMFToString(cx, obj, "MFColorRGBA", &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;

}

JSBool
MFColorRGBAAssign(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;
	if (!_standardMFAssign(cx, obj, argc, argv, &rval, &MFColorRGBAClass, FIELDTYPE_SFColorRGBA)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;

}

JSBool
MFColorRGBAConstr(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_NewObject(cx, &MFColorRGBAClass, NULL, NULL);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval = OBJECT_TO_JSVAL(obj);
	if (!MFColorRGBAConstrInternals(cx, obj, argc, argv, &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;
}
JSBool MFColorRGBAConstrInternals(JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval) {

	JSObject* _arrayObj;
	int isArray;
	JSObject* _obj;
	unsigned int i;
	union anyVrml* anyv;

	ADD_ROOT(cx, obj)

		isArray = FALSE;
	if (argc == 1 && argv) {
		//could it be new MFxxx( [A,B] ) javscript array, as used by Carlson aka Carlson Array
		// tests/JohnCarlson/Arc1A.x3d
		if (!JS_ValueToObject(cx, argv[0], &_arrayObj)) {
			printf("JS_ValueToObject failed in MFVec3fConstr.\n");
			return JS_FALSE;
		}

		if (JS_IsArrayObject(cx, _arrayObj)) {
			jsuint lengthp;
			jsval vp;
			//printf("its an array\n");
			isArray = TRUE;
			JS_GetArrayLength(cx, _arrayObj, &lengthp);
			argc = lengthp;
		}
	}

	if (SM_method() == 2) {
		AnyNative* any;
		int newsize;
		if ((any = (AnyNative*)AnyNativeNew(FIELDTYPE_MFColorRGBA, NULL, NULL)) == NULL) {
			printf("AnyfNativeNew failed in MFColorRGBAConstr.\n");
			return JS_FALSE;
		}
		if (!JS_SetPrivateFw(cx, obj, any)) {
			printf("JS_SetPrivate failed in MFColorRGBAConstr.\n");
			return JS_FALSE;
		}
		anyv = any->v;
		newsize = sizeof(struct SFColorRGBA) * upper_power_of_two(argc);
		if (argc > 0) {
			anyv->mfcolorrgba.p = MALLOC(struct SFColorRGBA*, newsize);
			memset(anyv->mfcolorrgba.p, 0, newsize);
		}

	}
	else {
		DEFINE_LENGTH(cx, obj, argc)
	}
	if (!argv) {
		return JS_TRUE;
	}

#ifdef JSVRMLCLASSESVERBOSE
	printf("MFColorRGBAConstr: obj = %p, %u args\n",
		obj, argc);
#endif

	for (i = 0; i < argc; i++) {
		jsval vp;
		if (isArray) {
			JS_GetElement(cx, _arrayObj, i, &vp);

		}
		else {
			vp = argv[i];
		}
		if (!JS_ValueToObject(cx, vp, &_obj)) {
			printf(
				"JS_ValueToObject failed in MFColorRGBAConstr.\n");
			return JS_FALSE;
		}

		CHECK_CLASS(cx, _obj, NULL, __FUNCTION__, SFColorRGBAClass)
			if (SM_method() == 2) {
				AnyNative* any2;
				if ((any2 = (AnyNative*)JS_GetPrivateFw(cx, _obj)) != NULL) {
					//2018 I think as long as its 4+ contiguous floats, we can use it as a colorrgba, 
					// but in future internal types might change
					if (any2->type == FIELDTYPE_SFColorRGBA || any2->type == FIELDTYPE_SFVec4f) {
						shallow_copy_field(FIELDTYPE_SFColorRGBA, any2->v, (union anyVrml*)&anyv->mfcolorrgba.p[i]);
						anyv->mfcolorrgba.n = i + 1;
					}
				}
				// else for now we'll leave zeros
			}
			else {
				if (!JS_DefineElement(cx, obj, (jsint)i, vp, JS_GET_PROPERTY_STUB, JS_SET_PROPERTY_CHECK, JSPROP_ENUMERATE)) {
					printf("JS_DefineElement failed for arg %u in MFColorRGBAConstr.\n", i);
					return JS_FALSE;
				}
			}
	}
	*rval = OBJECT_TO_JSVAL(obj);
	return JS_TRUE;
}

JSBool

MFColorRGBAAddProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

	return doMFAddProperty(cx, obj, id, vp, "MFColorRGBAAddProperty");
}

JSBool
MFColorRGBAGetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

	return _standardMFGetProperty(cx, obj, id, vp,
		"_FreeWRL_Internal = new SFColorRGBA()", FIELDTYPE_MFColorRGBA);
}

JSBool
MFColorRGBASetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JSBool strict, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

	return doMFSetProperty(cx, obj, id, vp, FIELDTYPE_MFColorRGBA);
}


// MFFloat
JSBool
MFFloatToString(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_THIS_OBJECT(cx,vp);
        jsval *argv = JS_ARGV(cx,vp);
        jsval rval;

	UNUSED(argc);
	UNUSED(argv);
	if (!doMFToString(cx, obj, "MFFloat", &rval)) { 
		return JS_FALSE; }
	JS_SET_RVAL(cx,vp,rval);
	return JS_TRUE;

}

JSBool
MFFloatAssign(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_THIS_OBJECT(cx,vp);
        jsval *argv = JS_ARGV(cx,vp);
        jsval rval;
	SET_MF_ECMA_HAS_CHANGED

	if (!_standardMFAssign (cx, obj, argc, argv, &rval, &MFFloatClass,FIELDTYPE_SFFloat)) { return JS_FALSE; }
        JS_SET_RVAL(cx,vp,rval);
        return JS_TRUE;
}

JSBool
MFFloatConstr(JSContext *cx, uintN argc, jsval *vp) {
		JSObject* obj = JS_NewObject(cx, &MFFloatClass, NULL, NULL);
        jsval *argv = JS_ARGV(cx,vp);
        jsval rval = OBJECT_TO_JSVAL(obj);
        if (!MFFloatConstrInternals(cx,obj,argc,argv,&rval)) { return JS_FALSE; }
        JS_SET_RVAL(cx,vp,rval);
        return JS_TRUE;
}
JSBool MFFloatConstrInternals(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval) {

	JSObject *_arrayObj;
	int isArray;

	jsdouble _d;
	unsigned int i;
	union anyVrml *anyv;

//	ADD_ROOT(cx,obj) only root non-stack variables

	isArray = FALSE;
	if(argc == 1 && argv){
		//could it be new MFxxx( [A,B] ) javscript array, as used by Carlson aka Carlson Array
		// tests/JohnCarlson/Arc1A.x3d
		if (!JS_ValueToObject(cx, argv[0], &_arrayObj)) {
			printf( "JS_ValueToObject failed in MFVec3fConstr.\n");
			return JS_FALSE;
		}

		if(JS_IsArrayObject(cx, _arrayObj)){
			jsuint lengthp;
			jsval vp;
			//printf("its an array\n");
			isArray = TRUE;
			JS_GetArrayLength(cx,_arrayObj, &lengthp);
			argc = lengthp;
		}
	}

	if(SM_method() == 2){
		AnyNative *any;
		if((any = (AnyNative*)AnyNativeNew(FIELDTYPE_MFFloat,NULL,NULL)) == NULL){
			printf( "AnyfNativeNew failed in MFFloatConstr.\n");
			return JS_FALSE;
		}
		if (!JS_SetPrivateFw(cx, obj, any)) {
			printf( "JS_SetPrivate failed in MFFloatConstr.\n");
			return JS_FALSE;
		}
		anyv = any->v;
		if(argc > 0)
			anyv->mffloat.p = (float*)malloc(sizeof(float)*upper_power_of_two(argc));

	}else{
		DEFINE_LENGTH(cx,obj,argc)
		DEFINE_MF_ECMA_HAS_CHANGED
	}

	if (!argv) {
		return JS_TRUE;
	}

	#ifdef JSVRMLCLASSESVERBOSE
		printf("MFFloatConstr: obj = %p, %u args\n", obj, argc);
	#endif
	for (i = 0; i < argc; i++) {
		jsval vp;
		if(isArray){
			JS_GetElement(cx, _arrayObj, i, &vp);

		}else{
			vp = argv[i];
		}
		if (!JS_ValueToNumber(cx, vp, &_d)) {
			printf( "JS_ValueToNumber failed in MFFloatConstr.\n");
			return JS_FALSE;
		}
		if(SM_method()==2){
			anyv->mffloat.p[i] = _d;
			anyv->mffloat.n = i+1;
		}else{
			if (!JS_DefineElement(cx, obj, (jsint) i, vp, JS_GET_PROPERTY_STUB, JS_SET_PROPERTY_CHECK, JSPROP_ENUMERATE)) {
				printf( "JS_DefineElement failed for arg %u in MFFloatConstr.\n", i);
				return JS_FALSE;
			}
		}
	}
	*rval = OBJECT_TO_JSVAL(obj);
	return JS_TRUE;
}

JSBool
MFFloatAddProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid,  JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();
	jsval *vp = hvp.address();
	return doMFAddProperty(cx, obj, id, vp,"MFFloatAddProperty");
}

JSBool
MFFloatGetProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid,  JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();
	jsval *vp = hvp.address();

	return _standardMFGetProperty(cx, obj, id, vp,
			"_FreeWRL_Internal = 0.0", FIELDTYPE_MFFloat);
}

JSBool
MFFloatSetProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JSBool strict, JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();
	jsval *vp = hvp.address();

	return doMFSetProperty(cx, obj, id, vp,FIELDTYPE_MFFloat);
}

// MFInt32
JSBool
MFInt32ToString(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_THIS_OBJECT(cx,vp);
        jsval *argv = JS_ARGV(cx,vp);
        jsval rval;

	UNUSED(argc);
	UNUSED(argv);
	#ifdef JSVRMLCLASSESVERBOSE
	printf ("start of MFInt32ToString\n");
	#endif

	if (!doMFToString(cx, obj, "MFInt32", &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx,vp,rval);
	return JS_TRUE;

}

JSBool
MFInt32Assign(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_THIS_OBJECT(cx,vp);
        jsval *argv = JS_ARGV(cx,vp);
        jsval rval;

	#ifdef JSVRMLCLASSESVERBOSE
	printf ("start of MFInt32Assign\n");
	#endif

	SET_MF_ECMA_HAS_CHANGED

	if (!_standardMFAssign (cx, obj, argc, argv, &rval, &MFInt32Class,FIELDTYPE_SFInt32)) { return JS_FALSE; }
	JS_SET_RVAL(cx,vp,rval);
	return JS_TRUE;

}


JSBool
MFInt32Constr(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_NewObject(cx,&MFInt32Class,NULL,NULL);
        jsval *argv = JS_ARGV(cx,vp);
        jsval rval = OBJECT_TO_JSVAL(obj);
        if (!MFInt32ConstrInternals(cx,obj,argc,argv,&rval)) { return JS_FALSE; }
        JS_SET_RVAL(cx,vp,rval);
        return JS_TRUE;
}
JSBool MFInt32ConstrInternals(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval) {

	JSObject *_arrayObj;
	int isArray;
	int32 _i;
	unsigned int i;
	union anyVrml *anyv;
	#ifdef JSVRMLCLASSESVERBOSE
	printf ("start of MFInt32Constr\n");
	#endif

	ADD_ROOT(cx,obj)
	isArray = FALSE;
	if(argc == 1 && argv){
		//could it be new MFxxx( [A,B] ) javscript array, as used by Carlson aka Carlson Array
		// tests/JohnCarlson/Arc1A.x3d
		if (!JS_ValueToObject(cx, argv[0], &_arrayObj)) {
			printf( "JS_ValueToObject failed in MFVec3fConstr.\n");
			return JS_FALSE;
		}

		if(JS_IsArrayObject(cx, _arrayObj)){
			jsuint lengthp;
			jsval vp;
			//printf("its an array\n");
			isArray = TRUE;
			JS_GetArrayLength(cx,_arrayObj, &lengthp);
			argc = lengthp;
		}
	}

	if(SM_method() == 2){
		AnyNative *any;
		int newsize;
		if((any = (AnyNative*)AnyNativeNew(FIELDTYPE_MFInt32,NULL,NULL)) == NULL){
			printf( "AnyfNativeNew failed in MFInt32Constr.\n");
			return JS_FALSE;
		}
		if (!JS_SetPrivateFw(cx, obj, any)) {
			printf( "JS_SetPrivate failed in MFInt32Constr.\n");
			return JS_FALSE;
		}
		anyv = any->v;
		newsize = sizeof(int) * upper_power_of_two(argc); //newsize in bytes
		if(argc > 0){
			anyv->mfint32.p = MALLOC(int*,newsize);
			memset(anyv->mfint32.p,0,newsize);
		}

	}else{
		DEFINE_LENGTH(cx,obj,argc)
        DEFINE_MF_ECMA_HAS_CHANGED
	}
	if (!argv) {
		return JS_TRUE;
	}

	#ifdef JSVRMLCLASSESVERBOSE
		printf("MFInt32Constr: obj = %p, %u args\n", obj, argc);
	#endif

	/* any values here that we should add in? */
	for (i = 0; i < argc; i++) {
		jsval vp;
		if(isArray){
			JS_GetElement(cx, _arrayObj, i, &vp);

		}else{
			vp = argv[i];
		}
		//if (!JS::ToInt32(cx, vp, &_i)) {
		//if (!JS::ToInt32(cx, vp, &_i)) {
		if(!vp.isInt32()){
			printf( "JS_ValueToInt32 failed in MFInt32Constr.\n");
			return JS_FALSE;
		}
		_i = vp.toInt32();
		#ifdef JSVRMLCLASSESVERBOSE
		printf ("value at %d is %d\n",i,_i);
		#endif
		if(SM_method()==2){
			anyv->mfint32.p[i] = _i;
			anyv->mfint32.n = i+1;
		}else{
			if (!JS_DefineElement(cx, obj, (jsint) i, vp, JS_GET_PROPERTY_STUB, JS_SET_PROPERTY_CHECK, JSPROP_ENUMERATE)) {
				printf( "JS_DefineElement failed for arg %u in MFInt32Constr.\n", i);
				return JS_FALSE;
			}
		}
	}

	*rval = OBJECT_TO_JSVAL(obj);
	return JS_TRUE;
}

JSBool
MFInt32AddProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid,  JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();
	jsval *vp = hvp.address();

	#ifdef JSVRMLCLASSESVERBOSE
	printf ("start of MFInt32AddProperty\n");
	#endif

	return doMFAddProperty(cx, obj, id, vp,"MFInt32AddProperty");
}

JSBool
MFInt32GetProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid,  JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();
	jsval *vp = hvp.address();
	
	#ifdef JSVRMLCLASSESVERBOSE
	printf ("start of MFInt32GetProperty\n");
	#endif

	return _standardMFGetProperty(cx, obj, id, vp,
			"_FreeWRL_Internal = 0", FIELDTYPE_MFInt32);
}

JSBool
MFInt32SetProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JSBool strict, JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();
	jsval *vp = hvp.address();

	#ifdef JSVRMLCLASSESVERBOSE
	printf ("start of MFInt32SetProperty\n");
	#endif

	return doMFSetProperty(cx, obj, id, vp,FIELDTYPE_MFInt32);
}

// MFBool
JSBool
MFBoolToString(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;

	UNUSED(argc);
	UNUSED(argv);
#ifdef JSVRMLCLASSESVERBOSE
	printf("start of MFBoolToString\n");
#endif

	if (!doMFToString(cx, obj, "MFBool", &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;

}

JSBool
MFBoolAssign(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;

#ifdef JSVRMLCLASSESVERBOSE
	printf("start of MFBoolAssign\n");
#endif

	SET_MF_ECMA_HAS_CHANGED

		if (!_standardMFAssign(cx, obj, argc, argv, &rval, &MFBoolClass, FIELDTYPE_SFBool)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;

}


JSBool
MFBoolConstr(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_NewObject(cx, &MFBoolClass, NULL, NULL);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval = OBJECT_TO_JSVAL(obj);
	if (!MFBoolConstrInternals(cx, obj, argc, argv, &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;
}
JSBool MFBoolConstrInternals(JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval) {

	JSObject* _arrayObj;
	int isArray;
	int32 _i;
	unsigned int i;
	union anyVrml* anyv;
#ifdef JSVRMLCLASSESVERBOSE
	printf("start of MFBoolConstr\n");
#endif

	ADD_ROOT(cx, obj)
		isArray = FALSE;
	if (argc == 1 && argv) {
		//could it be new MFxxx( [A,B] ) javscript array, as used by Carlson aka Carlson Array
		// tests/JohnCarlson/Arc1A.x3d
		if (!JS_ValueToObject(cx, argv[0], &_arrayObj)) {
			printf("JS_ValueToObject failed in MFBoolConstr.\n");
			return JS_FALSE;
		}

		if (JS_IsArrayObject(cx, _arrayObj)) {
			jsuint lengthp;
			jsval vp;
			//printf("its an array\n");
			isArray = TRUE;
			JS_GetArrayLength(cx, _arrayObj, &lengthp);
			argc = lengthp;
		}
	}

	if (SM_method() == 2) {
		AnyNative* any;
		int newsize;
		if ((any = (AnyNative*)AnyNativeNew(FIELDTYPE_MFBool, NULL, NULL)) == NULL) {
			printf("AnyfNativeNew failed in MFBoolConstr.\n");
			return JS_FALSE;
		}
		if (!JS_SetPrivateFw(cx, obj, any)) {
			printf("JS_SetPrivate failed in MFBoolConstr.\n");
			return JS_FALSE;
		}
		anyv = any->v;
		newsize = sizeof(int) * upper_power_of_two(argc); //newsize in bytes
		if (argc > 0) {
			anyv->mfbool.p = MALLOC(int*, newsize);
			memset(anyv->mfbool.p, 0, newsize);
		}

	}
	else {
		DEFINE_LENGTH(cx, obj, argc)
			DEFINE_MF_ECMA_HAS_CHANGED
	}
	if (!argv) {
		return JS_TRUE;
	}

#ifdef JSVRMLCLASSESVERBOSE
	printf("MFBoolConstr: obj = %p, %u args\n", obj, argc);
#endif

	/* any values here that we should add in? */
	for (i = 0; i < argc; i++) {
		jsval vp;
		if (isArray) {
			JS_GetElement(cx, _arrayObj, i, &vp);

		}
		else {
			vp = argv[i];
		}
		//if (!JS::ToInt32(cx, vp, &_i)) {
		//if (!JS::ToInt32(cx, vp, &_i)) {
		if (!vp.isInt32()) {
			printf("JS_ValueToInt32 failed in MFBoolConstr.\n");
			return JS_FALSE;
		}
		_i = vp.toInt32();
#ifdef JSVRMLCLASSESVERBOSE
		printf("value at %d is %d\n", i, _i);
#endif
		if (SM_method() == 2) {
			anyv->mfbool.p[i] = _i;
			anyv->mfbool .n = i + 1;
		}
		else {
			if (!JS_DefineElement(cx, obj, (jsint)i, vp, JS_GET_PROPERTY_STUB, JS_SET_PROPERTY_CHECK, JSPROP_ENUMERATE)) {
				printf("JS_DefineElement failed for arg %u in MFBoolConstr.\n", i);
				return JS_FALSE;
			}
		}
	}

	*rval = OBJECT_TO_JSVAL(obj);
	return JS_TRUE;
}

JSBool
MFBoolAddProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

#ifdef JSVRMLCLASSESVERBOSE
	printf("start of MFBoolAddProperty\n");
#endif

	return doMFAddProperty(cx, obj, id, vp, "MFBoolAddProperty");
}

JSBool
MFBoolGetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

#ifdef JSVRMLCLASSESVERBOSE
	printf("start of MFBoolGetProperty\n");
#endif

	return _standardMFGetProperty(cx, obj, id, vp,
		"_FreeWRL_Internal = 0", FIELDTYPE_MFBool);
}

JSBool
MFBoolSetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JSBool strict, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

#ifdef JSVRMLCLASSESVERBOSE
	printf("start of MFBoolSetProperty\n");
#endif

	return doMFSetProperty(cx, obj, id, vp, FIELDTYPE_MFBool);
}


// MFNode

JSBool
MFNodeToString(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_THIS_OBJECT(cx,vp);
        jsval *argv = JS_ARGV(cx,vp);
        jsval rval;

	UNUSED(argc);
	UNUSED(argv);
	
	#ifdef JSVRMLCLASSESVERBOSE
	printf ("start of MFNODETOSTRING, obj %p\n",obj);
	#endif
	if (!doMFToString(cx, obj, "MFNode", &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx,vp,rval);
	return JS_TRUE;

}

JSBool
MFNodeAssign(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_THIS_OBJECT(cx,vp);
        jsval *argv = JS_ARGV(cx,vp);
        jsval rval;

	#ifdef JSVRMLCLASSESVERBOSE
	printf ("start of MFNODEASSIGN, obj %p\n",obj);
	#endif

	if (!_standardMFAssign (cx, obj, argc, argv, &rval, &MFNodeClass,FIELDTYPE_SFNode)) { return JS_FALSE; }
	JS_SET_RVAL(cx,vp,rval);
	return JS_TRUE;

}

JSBool
MFNodeConstr(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_NewObject(cx,&MFNodeClass,NULL,NULL);
        jsval *argv = JS_ARGV(cx,vp);
        jsval rval = OBJECT_TO_JSVAL(obj);
        if (!MFNodeConstrInternals(cx,obj,argc,argv,&rval)) { return JS_FALSE; }
        JS_SET_RVAL(cx,vp,rval);
        return JS_TRUE;
}
JSBool MFNodeConstrInternals(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval) {

	JSObject *_arrayObj;
	int isArray;
	JSObject *_obj;
	unsigned int i;
	union anyVrml *anyv;

	ADD_ROOT(cx,obj)
	isArray = FALSE;
	if(argc == 1 && argv){
		//could it be new MFxxx( [A,B] ) javscript array, as used by Carlson aka Carlson Array
		// tests/JohnCarlson/Arc1A.x3d
		if (!JS_ValueToObject(cx, argv[0], &_arrayObj)) {
			printf( "JS_ValueToObject failed in MFVec3fConstr.\n");
			return JS_FALSE;
		}

		if(JS_IsArrayObject(cx, _arrayObj)){
			jsuint lengthp;
			jsval vp;
			//printf("its an array\n");
			isArray = TRUE;
			JS_GetArrayLength(cx,_arrayObj, &lengthp);
			argc = lengthp;
		}
	}

	if(SM_method() == 2){
		AnyNative *any;
		int newsize;
		if((any = (AnyNative*)AnyNativeNew(FIELDTYPE_MFNode,NULL,NULL)) == NULL){
			printf( "AnyfNativeNew failed in MFNodeConstr.\n");
			return JS_FALSE;
		}
		if (!JS_SetPrivateFw(cx, obj, any)) {
			printf( "JS_SetPrivate failed in MFNodeConstr.\n");
			return JS_FALSE;
		}
		anyv = any->v;
		newsize = sizeof(struct X3D_Node *) * upper_power_of_two(argc); //newsize in bytes
		if(argc > 0){
			anyv->mfnode.p = MALLOC(struct X3D_Node**,newsize);
			memset(anyv->mfnode.p,0,newsize);
		}

	}else{
		DEFINE_LENGTH(cx,obj,argc)
	}
	if (!argv) {
		return JS_TRUE;
	}

	#ifdef JSVRMLCLASSESVERBOSE
		printf("MFNodeConstr: obj = %p, %u args\n", obj, argc);
	#endif

	for (i = 0; i < argc; i++) {
		jsval vp;
		if(isArray){
			JS_GetElement(cx, _arrayObj, i, &vp);

		}else{
			vp = argv[i];
		}
		//if (JSVAL_IS_OBJECT(vp)) {
		if ((vp).isObject()) {

			if (!JS_ValueToObject(cx, vp, &_obj)) {
				printf( "JS_ValueToObject failed in MFNodeConstr.\n");
				return JS_FALSE;
			}

			CHECK_CLASS(cx,_obj,NULL,__FUNCTION__,SFNodeClass)
			if(SM_method()==2){
				AnyNative *any2;
				if((any2 = (AnyNative *)JS_GetPrivateFw(cx,_obj)) != NULL){
					if(any2->type == FIELDTYPE_SFNode){
						shallow_copy_field(FIELDTYPE_SFNode,any2->v,(union anyVrml*)&anyv->mfnode.p[i]);
						anyv->mfnode.n = i+1;
					}
				}
				// else for now we'll leave zeros
			}else{
				if (!JS_DefineElement(cx, obj, (jsint) i, vp, JS_GET_PROPERTY_STUB, JS_SET_PROPERTY_CHECK, JSPROP_ENUMERATE)) {
					printf( "JS_DefineElement failed for arg %d in MFNodeConstr.\n", i);
					return JS_FALSE;
				}
			}
		} else {
			/* if a NULL is passed in, eg, we have a script with an MFNode eventOut, and
			   nothing sets it, we have a NULL here. Lets just ignore it */
			/* hmmm - this is not an object - lets see... */
			#ifdef JSVRMLCLASSESVERBOSE
			if (JSVAL_IS_NULL(argv[i])) { printf ("MFNodeConstr - its a NULL\n");}
			if (JSVAL_IS_INT(argv[i])) { printf ("MFNodeConstr - its a INT\n");}
			if (JSVAL_IS_STRING(argv[i])) { printf ("MFNodeConstr - its a STRING\n");}
			#endif
		}
	}
	*rval = OBJECT_TO_JSVAL(obj);
	return JS_TRUE;
}

JSBool
MFNodeAddProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid,  JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();
	jsval *vp = hvp.address();

	#ifdef JSVRMLCLASSESVERBOSE
	printf ("startof MFNODEADDPROPERTY\n");
	#endif
	return doMFAddProperty(cx, obj, id, vp,"MFNodeAddProperty");
}

JSBool
MFNodeGetProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid,  JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();
	jsval *vp = hvp.address();

	#ifdef JSVRMLCLASSESVERBOSE
	printf ("start of MFNODEGETPROPERTY obj %p\n",obj);
	#endif
	return _standardMFGetProperty(cx, obj, id, vp,
			"_FreeWRL_Internal = 0",
			FIELDTYPE_MFNode);
}

JSBool
MFNodeSetProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JSBool strict, JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();
	jsval *vp = hvp.address();
	/* printf ("start of MFNODESETPROPERTY obj %d\n",obj); */
	return doMFSetProperty(cx, obj, id, vp,FIELDTYPE_MFNode);
}

// MFTime

JSBool
MFTimeAddProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid,  JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();
	jsval *vp = hvp.address();

	return doMFAddProperty(cx, obj, id, vp,"MFTimeAddProperty");
}

JSBool
MFTimeGetProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid,  JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();
	jsval *vp = hvp.address();

	return _standardMFGetProperty(cx, obj, id, vp,
			 "_FreeWRL_Internal = 0.0",
			FIELDTYPE_MFTime);
}

JSBool
MFTimeSetProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JSBool strict, JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();
	jsval *vp = hvp.address();

	return doMFSetProperty(cx, obj, id, vp,FIELDTYPE_MFTime);
}

JSBool
MFTimeToString(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_THIS_OBJECT(cx,vp);
        jsval *argv = JS_ARGV(cx,vp);
	jsval rval;

	UNUSED(argc);
	UNUSED(argv);
	if (!doMFToString(cx, obj, "MFTime", &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx,vp,rval);
	return JS_TRUE;

}

JSBool
MFTimeConstr(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_NewObject(cx,&MFTimeClass,NULL,NULL);
        jsval *argv = JS_ARGV(cx,vp);
        jsval rval = OBJECT_TO_JSVAL(obj);
        if (!MFTimeConstrInternals(cx,obj,argc,argv,&rval)) { return JS_FALSE; }
        JS_SET_RVAL(cx,vp,rval);
        return JS_TRUE;
}
JSBool MFTimeConstrInternals(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval) {

	JSObject *_arrayObj;
	int isArray;
	jsdouble _d;
	unsigned int i;
	union anyVrml *anyv;

	ADD_ROOT(cx,obj)
	isArray = FALSE;
	if(argc == 1 && argv){
		//could it be new MFxxx( [A,B] ) javscript array, as used by Carlson aka Carlson Array
		// tests/JohnCarlson/Arc1A.x3d
		if (!JS_ValueToObject(cx, argv[0], &_arrayObj)) {
			printf( "JS_ValueToObject failed in MFVec3fConstr.\n");
			return JS_FALSE;
		}

		if(JS_IsArrayObject(cx, _arrayObj)){
			jsuint lengthp;
			jsval vp;
			//printf("its an array\n");
			isArray = TRUE;
			JS_GetArrayLength(cx,_arrayObj, &lengthp);
			argc = lengthp;
		}
	}

	if(SM_method() == 2){
		AnyNative *any;
		int newsize;
		if((any = (AnyNative*)AnyNativeNew(FIELDTYPE_MFTime,NULL,NULL)) == NULL){
			printf( "AnyfNativeNew failed in MFTimeConstr.\n");
			return JS_FALSE;
		}
		if (!JS_SetPrivateFw(cx, obj, any)) {
			printf( "JS_SetPrivate failed in MFTimeConstr.\n");
			return JS_FALSE;
		}
		anyv = any->v;
		newsize = sizeof(double) * upper_power_of_two(argc); //newsize in bytes
		if(argc > 0){
			anyv->mftime.p = MALLOC(double*,newsize);
			memset(anyv->mftime.p,0,newsize);
		}

	}else{
		DEFINE_LENGTH(cx,obj,argc)
		DEFINE_MF_ECMA_HAS_CHANGED
	}
	if (!argv) {
		return JS_TRUE;
	}

	#ifdef JSVRMLCLASSESVERBOSE
		printf("MFTimeConstr: obj = %p, %u args\n", obj, argc);
	#endif
	for (i = 0; i < argc; i++) {
		jsval vp;
		if(isArray){
			JS_GetElement(cx, _arrayObj, i, &vp);

		}else{
			vp = argv[i];
		}
		if (!JS_ValueToNumber(cx, vp, &_d)) {
			printf(
					"JS_ValueToNumber failed in MFTimeConstr.\n");
			return JS_FALSE;
		}
		if(SM_method()==2){
			anyv->mftime.p[i] = _d;
			anyv->mftime.n = i+1;
		}else{
			if (!JS_DefineElement(cx, obj, (jsint) i, vp, JS_GET_PROPERTY_STUB, JS_SET_PROPERTY_CHECK, JSPROP_ENUMERATE)) {
				printf( "JS_DefineElement failed for arg %u in MFTimeConstr.\n", i);
				return JS_FALSE;
			}
		}
	}
	*rval = OBJECT_TO_JSVAL(obj);
	return JS_TRUE;
}

JSBool
MFTimeAssign(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_THIS_OBJECT(cx,vp);
        jsval *argv = JS_ARGV(cx,vp);
        jsval rval;

	SET_MF_ECMA_HAS_CHANGED

	if (!_standardMFAssign (cx, obj, argc, argv, &rval, &MFTimeClass,FIELDTYPE_SFTime)) { return JS_FALSE; }
	JS_SET_RVAL(cx,vp,rval);
	return JS_TRUE;

}

// MFDouble

JSBool
MFDoubleAddProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

	return doMFAddProperty(cx, obj, id, vp, "MFDoubleAddProperty");
}

JSBool
MFDoubleGetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

	return _standardMFGetProperty(cx, obj, id, vp,
		"_FreeWRL_Internal = 0.0",
		FIELDTYPE_MFDouble);
}

JSBool
MFDoubleSetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JSBool strict, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

	return doMFSetProperty(cx, obj, id, vp, FIELDTYPE_MFDouble);
}

JSBool
MFDoubleToString(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;

	UNUSED(argc);
	UNUSED(argv);
	if (!doMFToString(cx, obj, "MFDouble", &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;

}

JSBool
MFDoubleConstr(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_NewObject(cx, &MFDoubleClass, NULL, NULL);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval = OBJECT_TO_JSVAL(obj);
	if (!MFDoubleConstrInternals(cx, obj, argc, argv, &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;
}
JSBool MFDoubleConstrInternals(JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval) {

	JSObject* _arrayObj;
	int isArray;
	jsdouble _d;
	unsigned int i;
	union anyVrml* anyv;

	ADD_ROOT(cx, obj)
		isArray = FALSE;
	if (argc == 1 && argv) {
		//could it be new MFxxx( [A,B] ) javscript array, as used by Carlson aka Carlson Array
		// tests/JohnCarlson/Arc1A.x3d
		if (!JS_ValueToObject(cx, argv[0], &_arrayObj)) {
			printf("JS_ValueToObject failed in MFVec3fConstr.\n");
			return JS_FALSE;
		}

		if (JS_IsArrayObject(cx, _arrayObj)) {
			jsuint lengthp;
			jsval vp;
			//printf("its an array\n");
			isArray = TRUE;
			JS_GetArrayLength(cx, _arrayObj, &lengthp);
			argc = lengthp;
		}
	}

	if (SM_method() == 2) {
		AnyNative* any;
		int newsize;
		if ((any = (AnyNative*)AnyNativeNew(FIELDTYPE_MFDouble, NULL, NULL)) == NULL) {
			printf("AnyfNativeNew failed in MFTimeConstr.\n");
			return JS_FALSE;
		}
		if (!JS_SetPrivateFw(cx, obj, any)) {
			printf("JS_SetPrivate failed in MFDoubleConstr.\n");
			return JS_FALSE;
		}
		anyv = any->v;
		newsize = sizeof(double) * upper_power_of_two(argc); //newsize in bytes
		if (argc > 0) {
			anyv->mfdouble.p = MALLOC(double*, newsize);
			memset(anyv->mfdouble.p, 0, newsize);
		}

	}
	else {
		DEFINE_LENGTH(cx, obj, argc)
			DEFINE_MF_ECMA_HAS_CHANGED
	}
	if (!argv) {
		return JS_TRUE;
	}

#ifdef JSVRMLCLASSESVERBOSE
	printf("MFDoubleConstr: obj = %p, %u args\n", obj, argc);
#endif
	for (i = 0; i < argc; i++) {
		jsval vp;
		if (isArray) {
			JS_GetElement(cx, _arrayObj, i, &vp);

		}
		else {
			vp = argv[i];
		}
		if (!JS_ValueToNumber(cx, vp, &_d)) {
			printf(
				"JS_ValueToNumber failed in MFDoubleConstr.\n");
			return JS_FALSE;
		}
		if (SM_method() == 2) {
			anyv->mfdouble.p[i] = _d;
			anyv->mfdouble.n = i + 1;
		}
		else {
			if (!JS_DefineElement(cx, obj, (jsint)i, vp, JS_GET_PROPERTY_STUB, JS_SET_PROPERTY_CHECK, JSPROP_ENUMERATE)) {
				printf("JS_DefineElement failed for arg %u in MFTimeConstr.\n", i);
				return JS_FALSE;
			}
		}
	}
	*rval = OBJECT_TO_JSVAL(obj);
	return JS_TRUE;
}

JSBool
MFDoubleAssign(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;

	SET_MF_ECMA_HAS_CHANGED

		if (!_standardMFAssign(cx, obj, argc, argv, &rval, &MFDoubleClass, FIELDTYPE_SFDouble)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;

}

// MFVec2f

JSBool
MFVec2fAddProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid,  JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();
	jsval *vp = hvp.address();

	return doMFAddProperty(cx, obj, id, vp,"MFVec2fAddProperty");
}

JSBool
MFVec2fGetProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid,  JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();
	jsval *vp = hvp.address();

	return _standardMFGetProperty(cx, obj, id, vp,
			 "_FreeWRL_Internal = new SFVec2f()",FIELDTYPE_MFVec2f);
}

JSBool
MFVec2fSetProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JSBool strict, JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();
	jsval *vp = hvp.address();

	return doMFSetProperty(cx, obj, id, vp,FIELDTYPE_MFVec2f);
}

JSBool
MFVec2fToString(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_THIS_OBJECT(cx,vp);
        jsval *argv = JS_ARGV(cx,vp);
        jsval rval;

	UNUSED(argc);
	UNUSED(argv);
	if (!doMFToString(cx, obj, "MFVec2f", &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx,vp,rval);
	return JS_TRUE;

}

JSBool
MFVec2fConstr(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_NewObject(cx,&MFVec2fClass,NULL,NULL);
        jsval *argv = JS_ARGV(cx,vp);
        jsval rval = OBJECT_TO_JSVAL(obj);
        if (!MFVec2fConstrInternals(cx,obj,argc,argv,&rval)) { return JS_FALSE; }
        JS_SET_RVAL(cx,vp,rval);
        return JS_TRUE;
}
JSBool MFVec2fConstrInternals(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval) {

	JSObject *_arrayObj;
	int isArray;
	JSObject *_obj;
	unsigned int i;
	union anyVrml *anyv;

	ADD_ROOT(cx,obj)
	isArray = FALSE;
	if(argc == 1 && argv){
		//could it be new MFxxx( [A,B] ) javscript array, as used by Carlson aka Carlson Array
		// tests/JohnCarlson/Arc1A.x3d
		if (!JS_ValueToObject(cx, argv[0], &_arrayObj)) {
			printf( "JS_ValueToObject failed in MFVec3fConstr.\n");
			return JS_FALSE;
		}

		if(JS_IsArrayObject(cx, _arrayObj)){
			jsuint lengthp;
			jsval vp;
			//printf("its an array\n");
			isArray = TRUE;
			JS_GetArrayLength(cx,_arrayObj, &lengthp);
			argc = lengthp;
		}
	}

	if(SM_method() == 2){
		AnyNative *any;
		int newsize;
		if((any = (AnyNative*)AnyNativeNew(FIELDTYPE_MFVec2f,NULL,NULL)) == NULL){
			printf( "AnyfNativeNew failed in MFVec2fConstr.\n");
			return JS_FALSE;
		}
		if (!JS_SetPrivateFw(cx, obj, any)) {
			printf( "JS_SetPrivate failed in MFVec2fConstr.\n");
			return JS_FALSE;
		}
		anyv = any->v;
		newsize = sizeof(struct SFVec2f)*upper_power_of_two(argc);
		if(argc > 0){
			anyv->mfvec2f.p = MALLOC(struct SFVec2f*,newsize);
			memset(anyv->mfvec2f.p,0,newsize);
		}

	}else{
		DEFINE_LENGTH(cx,obj,argc)
	}

	if (!argv) {
		return JS_TRUE;
	}

	#ifdef JSVRMLCLASSESVERBOSE
		printf("MFVec2fConstr: obj = %p, %u args\n", obj, argc);
	#endif

	for (i = 0; i < argc; i++) {
		jsval vp;
		if(isArray){
			JS_GetElement(cx, _arrayObj, i, &vp);

		}else{
			vp = argv[i];
		}
		if (!JS_ValueToObject(cx, vp, &_obj)) {
			printf( "JS_ValueToObject failed in MFVec2fConstr.\n");
			return JS_FALSE;
		}

		CHECK_CLASS(cx,_obj,NULL,__FUNCTION__,SFVec2fClass)
		if(SM_method()==2){
			AnyNative *any2;
			if((any2 = (AnyNative *)JS_GetPrivateFw(cx,_obj)) != NULL){
				//2018 I think as long as its 2+ contiguous floats, we can use it as a vec2f, 
				// but in future internal types might change
				if(any2->type == FIELDTYPE_SFVec2f || any2->type == FIELDTYPE_SFColor || any2->type == FIELDTYPE_SFVec3f || any2->type == FIELDTYPE_SFColorRGBA){
					shallow_copy_field(FIELDTYPE_SFVec2f,any2->v,(union anyVrml*)&anyv->mfvec2f.p[i]);
					anyv->mfvec2f.n = i+1;
				}
			}
			// else for now we'll leave zeros
		}else{
			if (!JS_DefineElement(cx, obj, (jsint) i, vp, JS_GET_PROPERTY_STUB, JS_SET_PROPERTY_CHECK, JSPROP_ENUMERATE)) {
				printf( "JS_DefineElement failed for arg %d in MFVec2fConstr.\n", i);
				return JS_FALSE;
			}
		}
	}
	*rval = OBJECT_TO_JSVAL(obj);
	return JS_TRUE;
}

JSBool
MFVec2fAssign(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_THIS_OBJECT(cx,vp);
        jsval *argv = JS_ARGV(cx,vp);
        jsval rval;
        if (!_standardMFAssign (cx, obj, argc, argv, &rval, &MFVec2fClass,FIELDTYPE_SFVec2f)) { return JS_FALSE; }
        JS_SET_RVAL(cx,vp,rval);
        return JS_TRUE;

}

// MFVec3f 
JSBool
MFVec3fAddProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid,  JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();
	jsval *vp = hvp.address();
	return doMFAddProperty(cx, obj, id, vp,"MFVec3fAddProperty");
}

JSBool
MFVec3fGetProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid,  JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();
	jsval *vp = hvp.address();

	return _standardMFGetProperty(cx, obj, id, vp,
			 "_FreeWRL_Internal = new SFVec3f()",FIELDTYPE_MFVec3f);
}

JSBool
MFVec3fSetProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JSBool strict, JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();
	jsval *vp = hvp.address();

	return doMFSetProperty(cx, obj, id, vp,FIELDTYPE_MFVec3f);
}

JSBool
MFVec3fToString(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_THIS_OBJECT(cx,vp);
        jsval *argv = JS_ARGV(cx,vp);
        jsval rval;

	UNUSED(argc);
	UNUSED(argv);
	/* printf ("CALLED MFVec3fToString\n");*/
        if (!doMFToString(cx, obj, "MFVec3f", &rval)) { return JS_FALSE; }
        JS_SET_RVAL(cx,vp,rval);
        return JS_TRUE;

}

JSBool
MFVec3fConstr(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_NewObject(cx,&MFVec3fClass,NULL,NULL);
        jsval *argv = JS_ARGV(cx,vp);
        jsval rval = OBJECT_TO_JSVAL(obj);
        if (!MFVec3fConstrInternals(cx,obj,argc,argv,&rval)) { return JS_FALSE; }
        JS_SET_RVAL(cx,vp,rval);
        return JS_TRUE;
}
JSBool MFVec3fConstrInternals(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval) {

	JSObject *_arrayObj;
	int isArray;
	JSObject *_obj;
	unsigned int i;
	union anyVrml *anyv;

	ADD_ROOT(cx,obj)

	isArray = FALSE;
	if(argc == 1 && argv){
		//could it be new MFxxx( [A,B] ) javscript array, as used by Carlson aka Carlson Array
		// tests/JohnCarlson/Arc1A.x3d
		if (!JS_ValueToObject(cx, argv[0], &_arrayObj)) {
			printf( "JS_ValueToObject failed in MFVec3fConstr.\n");
			return JS_FALSE;
		}

		if(JS_IsArrayObject(cx, _arrayObj)){
			jsuint lengthp;
			jsval vp;
			//printf("its an array\n");
			isArray = TRUE;
			JS_GetArrayLength(cx,_arrayObj, &lengthp);
			argc = lengthp;
		}
	}



	if(SM_method() == 2){
		AnyNative *any;
		int newsize;
		if((any = (AnyNative*)AnyNativeNew(FIELDTYPE_MFVec3f,NULL,NULL)) == NULL){
			printf( "AnyfNativeNew failed in MFVec3fConstr.\n");
			return JS_FALSE;
		}
		if (!JS_SetPrivateFw(cx, obj, any)) {
			printf( "JS_SetPrivate failed in MFVec3fConstr.\n");
			return JS_FALSE;
		}
		anyv = any->v;
		newsize = sizeof(struct SFVec3f)*upper_power_of_two(argc);
		if(argc > 0){
			anyv->mfvec3f.p = MALLOC(struct SFVec3f*,newsize);
			memset(anyv->mfvec3f.p,0,newsize);
		}

	}else{
		DEFINE_LENGTH(cx,obj,argc)
	}
	if (!argv) {
		return JS_TRUE;
	}

	#ifdef JSVRMLCLASSESVERBOSE
		printf("MFVec3fConstr: obj = %p, %u args\n", obj, argc);
	#endif	
	for (i = 0; i < argc; i++) {
		jsval vp;
		if(isArray){
			JS_GetElement(cx, _arrayObj, i, &vp);

		}else{
			vp = argv[i];
		}
		if (!JS_ValueToObject(cx, vp, &_obj)) {
			printf( "JS_ValueToObject failed in MFVec3fConstr.\n");
			return JS_FALSE;
		}

		CHECK_CLASS(cx,_obj,NULL,__FUNCTION__,SFVec3fClass)

		if(SM_method()==2){
			AnyNative *any2;
			if((any2 = (AnyNative *)JS_GetPrivateFw(cx,_obj)) != NULL){
				//2018 I think as long as its 3+ contiguous floats, we can use it as a vec2f, 
				// but in future internal types might change
				if(any2->type == FIELDTYPE_SFVec3f || any2->type == FIELDTYPE_SFColor || any2->type == FIELDTYPE_SFColorRGBA){
					shallow_copy_field(FIELDTYPE_SFVec3f,any2->v,(union anyVrml*)&anyv->mfvec3f.p[i]);
					anyv->mfvec3f.n = i+1;
				}
			}
			// else for now we'll leave zeros
		}else{

			if (!JS_DefineElement(cx, obj, (jsint) i, vp, JS_GET_PROPERTY_STUB, JS_SET_PROPERTY_CHECK, JSPROP_ENUMERATE)) {
				printf( "JS_DefineElement failed for arg %d in MFVec3fConstr.\n", i);
				return JS_FALSE;
			}
		}
	}
	*rval = OBJECT_TO_JSVAL(obj);
	return JS_TRUE;
}

JSBool
MFVec3fAssign(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_THIS_OBJECT(cx,vp);
        jsval *argv = JS_ARGV(cx,vp);
        jsval rval;
        if (!_standardMFAssign (cx, obj, argc, argv, &rval, &MFVec3fClass,FIELDTYPE_SFVec3f)) { return JS_FALSE; }
        JS_SET_RVAL(cx,vp,rval);
        return JS_TRUE;
}


// MFVec4f
JSBool
MFVec4fAddProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();
	return doMFAddProperty(cx, obj, id, vp, "MFVec4fAddProperty");
}

JSBool
MFVec4fGetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

	return _standardMFGetProperty(cx, obj, id, vp,
		"_FreeWRL_Internal = new SFVec4f()", FIELDTYPE_MFVec4f);
}

JSBool
MFVec4fSetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JSBool strict, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

	return doMFSetProperty(cx, obj, id, vp, FIELDTYPE_MFVec4f);
}

JSBool
MFVec4fToString(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;

	UNUSED(argc);
	UNUSED(argv);
	/* printf ("CALLED MFVec4fToString\n");*/
	if (!doMFToString(cx, obj, "MFVec4f", &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;

}

JSBool
MFVec4fConstr(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_NewObject(cx, &MFVec4fClass, NULL, NULL);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval = OBJECT_TO_JSVAL(obj);
	if (!MFVec4fConstrInternals(cx, obj, argc, argv, &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;
}
JSBool MFVec4fConstrInternals(JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval) {

	JSObject* _arrayObj;
	int isArray;
	JSObject* _obj;
	unsigned int i;
	union anyVrml* anyv;

	ADD_ROOT(cx, obj)

		isArray = FALSE;
	if (argc == 1 && argv) {
		//could it be new MFxxx( [A,B] ) javscript array, as used by Carlson aka Carlson Array
		// tests/JohnCarlson/Arc1A.x3d
		if (!JS_ValueToObject(cx, argv[0], &_arrayObj)) {
			printf("JS_ValueToObject failed in MFVec4fConstr.\n");
			return JS_FALSE;
		}

		if (JS_IsArrayObject(cx, _arrayObj)) {
			jsuint lengthp;
			jsval vp;
			//printf("its an array\n");
			isArray = TRUE;
			JS_GetArrayLength(cx, _arrayObj, &lengthp);
			argc = lengthp;
		}
	}



	if (SM_method() == 2) {
		AnyNative* any;
		int newsize;
		if ((any = (AnyNative*)AnyNativeNew(FIELDTYPE_MFVec4f, NULL, NULL)) == NULL) {
			printf("AnyfNativeNew failed in MFVec4fConstr.\n");
			return JS_FALSE;
		}
		if (!JS_SetPrivateFw(cx, obj, any)) {
			printf("JS_SetPrivate failed in MFVec4fConstr.\n");
			return JS_FALSE;
		}
		anyv = any->v;
		newsize = sizeof(struct SFVec4f) * upper_power_of_two(argc);
		if (argc > 0) {
			anyv->mfvec4f.p = MALLOC(struct SFVec4f*, newsize);
			memset(anyv->mfvec4f.p, 0, newsize);
		}

	}
	else {
		DEFINE_LENGTH(cx, obj, argc)
	}
	if (!argv) {
		return JS_TRUE;
	}

#ifdef JSVRMLCLASSESVERBOSE
	printf("MFVec4fConstr: obj = %p, %u args\n", obj, argc);
#endif	
	for (i = 0; i < argc; i++) {
		jsval vp;
		if (isArray) {
			JS_GetElement(cx, _arrayObj, i, &vp);

		}
		else {
			vp = argv[i];
		}
		if (!JS_ValueToObject(cx, vp, &_obj)) {
			printf("JS_ValueToObject failed in MFVec4fConstr.\n");
			return JS_FALSE;
		}

		CHECK_CLASS(cx, _obj, NULL, __FUNCTION__, SFVec4fClass)

			if (SM_method() == 2) {
				AnyNative* any2;
				if ((any2 = (AnyNative*)JS_GetPrivateFw(cx, _obj)) != NULL) {
					//2018 I think as long as its 3+ contiguous floats, we can use it as a vec2f, 
					// but in future internal types might change
					if (any2->type == FIELDTYPE_SFVec4f || any2->type == FIELDTYPE_SFColorRGBA) {
						shallow_copy_field(FIELDTYPE_SFVec4f, any2->v, (union anyVrml*)&anyv->mfvec4f.p[i]);
						anyv->mfvec4f.n = i + 1;
					}
				}
				// else for now we'll leave zeros
			}
			else {

				if (!JS_DefineElement(cx, obj, (jsint)i, vp, JS_GET_PROPERTY_STUB, JS_SET_PROPERTY_CHECK, JSPROP_ENUMERATE)) {
					printf("JS_DefineElement failed for arg %d in MFVec4fConstr.\n", i);
					return JS_FALSE;
				}
			}
	}
	*rval = OBJECT_TO_JSVAL(obj);
	return JS_TRUE;
}

JSBool
MFVec4fAssign(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;
	if (!_standardMFAssign(cx, obj, argc, argv, &rval, &MFVec4fClass, FIELDTYPE_SFVec4f)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;
}



//MFVec2d
JSBool
MFVec2dAddProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();
	return doMFAddProperty(cx, obj, id, vp, "MFVec2dAddProperty");
}

JSBool
MFVec2dGetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

	return _standardMFGetProperty(cx, obj, id, vp,
		"_FreeWRL_Internal = new SFVec2d()", FIELDTYPE_MFVec2d);
}

JSBool
MFVec2dSetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JSBool strict, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

	return doMFSetProperty(cx, obj, id, vp, FIELDTYPE_MFVec2d);
}

JSBool
MFVec2dToString(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;

	UNUSED(argc);
	UNUSED(argv);
	/* printf ("CALLED MFVec2dToString\n");*/
	if (!doMFToString(cx, obj, "MFVec2d", &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;

}

JSBool
MFVec2dConstr(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_NewObject(cx, &MFVec2dClass, NULL, NULL);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval = OBJECT_TO_JSVAL(obj);
	if (!MFVec2dConstrInternals(cx, obj, argc, argv, &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;
}
JSBool MFVec2dConstrInternals(JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval) {

	JSObject* _arrayObj;
	int isArray;
	JSObject* _obj;
	unsigned int i;
	union anyVrml* anyv;

	ADD_ROOT(cx, obj)

		isArray = FALSE;
	if (argc == 1 && argv) {
		//could it be new MFxxx( [A,B] ) javscript array, as used by Carlson aka Carlson Array
		// tests/JohnCarlson/Arc1A.x3d
		if (!JS_ValueToObject(cx, argv[0], &_arrayObj)) {
			printf("JS_ValueToObject failed in MFVec2dConstr.\n");
			return JS_FALSE;
		}

		if (JS_IsArrayObject(cx, _arrayObj)) {
			jsuint lengthp;
			jsval vp;
			//printf("its an array\n");
			isArray = TRUE;
			JS_GetArrayLength(cx, _arrayObj, &lengthp);
			argc = lengthp;
		}
	}



	if (SM_method() == 2) {
		AnyNative* any;
		int newsize;
		if ((any = (AnyNative*)AnyNativeNew(FIELDTYPE_MFVec2d, NULL, NULL)) == NULL) {
			printf("AnyfNativeNew failed in MFVec2dConstr.\n");
			return JS_FALSE;
		}
		if (!JS_SetPrivateFw(cx, obj, any)) {
			printf("JS_SetPrivate failed in MFVec2dConstr.\n");
			return JS_FALSE;
		}
		anyv = any->v;
		newsize = sizeof(struct SFVec2d) * upper_power_of_two(argc);
		if (argc > 0) {
			anyv->mfvec2d.p = MALLOC(struct SFVec2d*, newsize);
			memset(anyv->mfvec2d.p, 0, newsize);
		}

	}
	else {
		DEFINE_LENGTH(cx, obj, argc)
	}
	if (!argv) {
		return JS_TRUE;
	}

#ifdef JSVRMLCLASSESVERBOSE
	printf("MFVec2dConstr: obj = %p, %u args\n", obj, argc);
#endif	
	for (i = 0; i < argc; i++) {
		jsval vp;
		if (isArray) {
			JS_GetElement(cx, _arrayObj, i, &vp);

		}
		else {
			vp = argv[i];
		}
		if (!JS_ValueToObject(cx, vp, &_obj)) {
			printf("JS_ValueToObject failed in MFVec2dConstr.\n");
			return JS_FALSE;
		}

		CHECK_CLASS(cx, _obj, NULL, __FUNCTION__, SFVec2dClass)

			if (SM_method() == 2) {
				AnyNative* any2;
				if ((any2 = (AnyNative*)JS_GetPrivateFw(cx, _obj)) != NULL) {
					//2018 I think as long as its 3+ contiguous floats, we can use it as a vec2f, 
					// but in future internal types might change
					if (any2->type == FIELDTYPE_SFVec2d || any2->type == FIELDTYPE_SFVec3d || any2->type == FIELDTYPE_SFVec4d) {
						shallow_copy_field(FIELDTYPE_SFVec2d, any2->v, (union anyVrml*)&anyv->mfvec2d.p[i]);
						anyv->mfvec2d.n = i + 1;
					}
				}
				// else for now we'll leave zeros
			}
			else {

				if (!JS_DefineElement(cx, obj, (jsint)i, vp, JS_GET_PROPERTY_STUB, JS_SET_PROPERTY_CHECK, JSPROP_ENUMERATE)) {
					printf("JS_DefineElement failed for arg %d in MFVec2dConstr.\n", i);
					return JS_FALSE;
				}
			}
	}
	*rval = OBJECT_TO_JSVAL(obj);
	return JS_TRUE;
}

JSBool
MFVec2dAssign(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;
	if (!_standardMFAssign(cx, obj, argc, argv, &rval, &MFVec2dClass, FIELDTYPE_SFVec2d)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;
}


// MFVec3d
JSBool
MFVec3dAddProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();
	return doMFAddProperty(cx, obj, id, vp, "MFVec3dAddProperty");
}

JSBool
MFVec3dGetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

	return _standardMFGetProperty(cx, obj, id, vp,
		"_FreeWRL_Internal = new SFVec3d()", FIELDTYPE_MFVec3d);
}

JSBool
MFVec3dSetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JSBool strict, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

	return doMFSetProperty(cx, obj, id, vp, FIELDTYPE_MFVec3d);
}

JSBool
MFVec3dToString(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;

	UNUSED(argc);
	UNUSED(argv);
	/* printf ("CALLED MFVec3dToString\n");*/
	if (!doMFToString(cx, obj, "MFVec3d", &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;

}

JSBool
MFVec3dConstr(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_NewObject(cx, &MFVec3dClass, NULL, NULL);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval = OBJECT_TO_JSVAL(obj);
	if (!MFVec3dConstrInternals(cx, obj, argc, argv, &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;
}
JSBool MFVec3dConstrInternals(JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval) {

	JSObject* _arrayObj;
	int isArray;
	JSObject* _obj;
	unsigned int i;
	union anyVrml* anyv;

	ADD_ROOT(cx, obj)

		isArray = FALSE;
	if (argc == 1 && argv) {
		//could it be new MFxxx( [A,B] ) javscript array, as used by Carlson aka Carlson Array
		// tests/JohnCarlson/Arc1A.x3d
		if (!JS_ValueToObject(cx, argv[0], &_arrayObj)) {
			printf("JS_ValueToObject failed in MFVec3dConstr.\n");
			return JS_FALSE;
		}

		if (JS_IsArrayObject(cx, _arrayObj)) {
			jsuint lengthp;
			jsval vp;
			//printf("its an array\n");
			isArray = TRUE;
			JS_GetArrayLength(cx, _arrayObj, &lengthp);
			argc = lengthp;
		}
	}



	if (SM_method() == 2) {
		AnyNative* any;
		int newsize;
		if ((any = (AnyNative*)AnyNativeNew(FIELDTYPE_MFVec3d, NULL, NULL)) == NULL) {
			printf("AnyfNativeNew failed in MFVec3dConstr.\n");
			return JS_FALSE;
		}
		if (!JS_SetPrivateFw(cx, obj, any)) {
			printf("JS_SetPrivate failed in MFVec3dConstr.\n");
			return JS_FALSE;
		}
		anyv = any->v;
		newsize = sizeof(struct SFVec3d) * upper_power_of_two(argc);
		if (argc > 0) {
			anyv->mfvec3d.p = MALLOC(struct SFVec3d*, newsize);
			memset(anyv->mfvec3d.p, 0, newsize);
		}

	}
	else {
		DEFINE_LENGTH(cx, obj, argc)
	}
	if (!argv) {
		return JS_TRUE;
	}

#ifdef JSVRMLCLASSESVERBOSE
	printf("MFVec3dConstr: obj = %p, %u args\n", obj, argc);
#endif	
	for (i = 0; i < argc; i++) {
		jsval vp;
		if (isArray) {
			JS_GetElement(cx, _arrayObj, i, &vp);

		}
		else {
			vp = argv[i];
		}
		if (!JS_ValueToObject(cx, vp, &_obj)) {
			printf("JS_ValueToObject failed in MFVec3dConstr.\n");
			return JS_FALSE;
		}

		CHECK_CLASS(cx, _obj, NULL, __FUNCTION__, SFVec3dClass)

			if (SM_method() == 2) {
				AnyNative* any2;
				if ((any2 = (AnyNative*)JS_GetPrivateFw(cx, _obj)) != NULL) {
					//2018 I think as long as its 3+ contiguous floats, we can use it as a vec2f, 
					// but in future internal types might change
					if (any2->type == FIELDTYPE_SFVec3d || any2->type == FIELDTYPE_SFVec4d) {
						shallow_copy_field(FIELDTYPE_SFVec3d, any2->v, (union anyVrml*)&anyv->mfvec3d.p[i]);
						anyv->mfvec3d.n = i + 1;
					}
				}
				// else for now we'll leave zeros
			}
			else {

				if (!JS_DefineElement(cx, obj, (jsint)i, vp, JS_GET_PROPERTY_STUB, JS_SET_PROPERTY_CHECK, JSPROP_ENUMERATE)) {
					printf("JS_DefineElement failed for arg %d in MFVec3dConstr.\n", i);
					return JS_FALSE;
				}
			}
	}
	*rval = OBJECT_TO_JSVAL(obj);
	return JS_TRUE;
}

JSBool
MFVec3dAssign(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;
	if (!_standardMFAssign(cx, obj, argc, argv, &rval, &MFVec3dClass, FIELDTYPE_SFVec3d)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;
}



// MFVec4d
JSBool
MFVec4dAddProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();
	return doMFAddProperty(cx, obj, id, vp, "MFVec4dAddProperty");
}

JSBool
MFVec4dGetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

	return _standardMFGetProperty(cx, obj, id, vp,
		"_FreeWRL_Internal = new SFVec4d()", FIELDTYPE_MFVec4d);
}

JSBool
MFVec4dSetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JSBool strict, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

	return doMFSetProperty(cx, obj, id, vp, FIELDTYPE_MFVec4d);
}

JSBool
MFVec4dToString(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;

	UNUSED(argc);
	UNUSED(argv);
	/* printf ("CALLED MFVec4dToString\n");*/
	if (!doMFToString(cx, obj, "MFVec4d", &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;

}

JSBool
MFVec4dConstr(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_NewObject(cx, &MFVec4dClass, NULL, NULL);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval = OBJECT_TO_JSVAL(obj);
	if (!MFVec4dConstrInternals(cx, obj, argc, argv, &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;
}
JSBool MFVec4dConstrInternals(JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval) {

	JSObject* _arrayObj;
	int isArray;
	JSObject* _obj;
	unsigned int i;
	union anyVrml* anyv;

	ADD_ROOT(cx, obj)

		isArray = FALSE;
	if (argc == 1 && argv) {
		//could it be new MFxxx( [A,B] ) javscript array, as used by Carlson aka Carlson Array
		// tests/JohnCarlson/Arc1A.x3d
		if (!JS_ValueToObject(cx, argv[0], &_arrayObj)) {
			printf("JS_ValueToObject failed in MFVec4dConstr.\n");
			return JS_FALSE;
		}

		if (JS_IsArrayObject(cx, _arrayObj)) {
			jsuint lengthp;
			jsval vp;
			//printf("its an array\n");
			isArray = TRUE;
			JS_GetArrayLength(cx, _arrayObj, &lengthp);
			argc = lengthp;
		}
	}



	if (SM_method() == 2) {
		AnyNative* any;
		int newsize;
		if ((any = (AnyNative*)AnyNativeNew(FIELDTYPE_MFVec4d, NULL, NULL)) == NULL) {
			printf("AnyfNativeNew failed in MFVec4dConstr.\n");
			return JS_FALSE;
		}
		if (!JS_SetPrivateFw(cx, obj, any)) {
			printf("JS_SetPrivate failed in MFVec4dConstr.\n");
			return JS_FALSE;
		}
		anyv = any->v;
		newsize = sizeof(struct SFVec4d) * upper_power_of_two(argc);
		if (argc > 0) {
			anyv->mfvec4d.p = MALLOC(struct SFVec4d*, newsize);
			memset(anyv->mfvec4d.p, 0, newsize);
		}

	}
	else {
		DEFINE_LENGTH(cx, obj, argc)
	}
	if (!argv) {
		return JS_TRUE;
	}

#ifdef JSVRMLCLASSESVERBOSE
	printf("MFVec4dConstr: obj = %p, %u args\n", obj, argc);
#endif	
	for (i = 0; i < argc; i++) {
		jsval vp;
		if (isArray) {
			JS_GetElement(cx, _arrayObj, i, &vp);

		}
		else {
			vp = argv[i];
		}
		if (!JS_ValueToObject(cx, vp, &_obj)) {
			printf("JS_ValueToObject failed in MFVec4dConstr.\n");
			return JS_FALSE;
		}

		CHECK_CLASS(cx, _obj, NULL, __FUNCTION__, SFVec4dClass)

			if (SM_method() == 2) {
				AnyNative* any2;
				if ((any2 = (AnyNative*)JS_GetPrivateFw(cx, _obj)) != NULL) {
					//2018 I think as long as its 3+ contiguous floats, we can use it as a vec2f, 
					// but in future internal types might change
					if (any2->type == FIELDTYPE_SFVec4d ) {
						shallow_copy_field(FIELDTYPE_SFVec4d, any2->v, (union anyVrml*)&anyv->mfvec4d.p[i]);
						anyv->mfvec4d.n = i + 1;
					}
				}
				// else for now we'll leave zeros
			}
			else {

				if (!JS_DefineElement(cx, obj, (jsint)i, vp, JS_GET_PROPERTY_STUB, JS_SET_PROPERTY_CHECK, JSPROP_ENUMERATE)) {
					printf("JS_DefineElement failed for arg %d in MFVec4dConstr.\n", i);
					return JS_FALSE;
				}
			}
	}
	*rval = OBJECT_TO_JSVAL(obj);
	return JS_TRUE;
}

JSBool
MFVec4dAssign(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;
	if (!_standardMFAssign(cx, obj, argc, argv, &rval, &MFVec4dClass, FIELDTYPE_SFVec4d)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;
}



// MFImage
JSBool
MFImageAddProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();
	return doMFAddProperty(cx, obj, id, vp, "MFImageAddProperty");
}

JSBool
MFImageGetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

	return _standardMFGetProperty(cx, obj, id, vp,
		"_FreeWRL_Internal = new SFImage()", FIELDTYPE_MFImage);
}

JSBool
MFImageSetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JSBool strict, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

	return doMFSetProperty(cx, obj, id, vp, FIELDTYPE_MFImage);
}

JSBool
MFImageToString(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;

	UNUSED(argc);
	UNUSED(argv);
	/* printf ("CALLED MFImageToString\n");*/
	if (!doMFToString(cx, obj, "MFImage", &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;

}

JSBool
MFImageConstr(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_NewObject(cx, &MFImageClass, NULL, NULL);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval = OBJECT_TO_JSVAL(obj);
	if (!MFImageConstrInternals(cx, obj, argc, argv, &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;
}
JSBool MFImageConstrInternals(JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval) {

	JSObject* _arrayObj;
	int isArray;
	JSObject* _obj;
	unsigned int i;
	union anyVrml* anyv;

	ADD_ROOT(cx, obj)

		isArray = FALSE;
	if (argc == 1 && argv) {
		//could it be new MFxxx( [A,B] ) javscript array, as used by Carlson aka Carlson Array
		// tests/JohnCarlson/Arc1A.x3d
		if (!JS_ValueToObject(cx, argv[0], &_arrayObj)) {
			printf("JS_ValueToObject failed in MFImageConstr.\n");
			return JS_FALSE;
		}

		if (JS_IsArrayObject(cx, _arrayObj)) {
			jsuint lengthp;
			jsval vp;
			//printf("its an array\n");
			isArray = TRUE;
			JS_GetArrayLength(cx, _arrayObj, &lengthp);
			argc = lengthp;
		}
	}



	if (SM_method() == 2) {
		AnyNative* any;
		int newsize;
		if ((any = (AnyNative*)AnyNativeNew(FIELDTYPE_MFImage, NULL, NULL)) == NULL) {
			printf("AnyfNativeNew failed in MFImageConstr.\n");
			return JS_FALSE;
		}
		if (!JS_SetPrivateFw(cx, obj, any)) {
			printf("JS_SetPrivate failed in MFImageConstr.\n");
			return JS_FALSE;
		}
		anyv = any->v;
		newsize = sizeof(struct SFImage) * upper_power_of_two(argc);
		if (argc > 0) {
			anyv->mfimage.p = MALLOC(struct SFImage*, newsize);
			memset(anyv->mfimage.p, 0, newsize);
		}

	}
	else {
		DEFINE_LENGTH(cx, obj, argc)
	}
	if (!argv) {
		return JS_TRUE;
	}

#ifdef JSVRMLCLASSESVERBOSE
	printf("MFImageConstr: obj = %p, %u args\n", obj, argc);
#endif	
	for (i = 0; i < argc; i++) {
		jsval vp;
		if (isArray) {
			JS_GetElement(cx, _arrayObj, i, &vp);

		}
		else {
			vp = argv[i];
		}
		if (!JS_ValueToObject(cx, vp, &_obj)) {
			printf("JS_ValueToObject failed in MFImageConstr.\n");
			return JS_FALSE;
		}

		CHECK_CLASS(cx, _obj, NULL, __FUNCTION__, SFImageClass)

			if (SM_method() == 2) {
				AnyNative* any2;
				if ((any2 = (AnyNative*)JS_GetPrivateFw(cx, _obj)) != NULL) {
					//2018 I think as long as its 3+ contiguous floats, we can use it as a vec2f, 
					// but in future internal types might change
					if (any2->type == FIELDTYPE_SFImage) {
						shallow_copy_field(FIELDTYPE_SFImage, any2->v, (union anyVrml*)&anyv->mfimage.p[i]);
						anyv->mfimage.n = i + 1;
					}
				}
				// else for now we'll leave zeros
			}
			else {

				if (!JS_DefineElement(cx, obj, (jsint)i, vp, JS_GET_PROPERTY_STUB, JS_SET_PROPERTY_CHECK, JSPROP_ENUMERATE)) {
					printf("JS_DefineElement failed for arg %d in MFImageConstr.\n", i);
					return JS_FALSE;
				}
			}
	}
	*rval = OBJECT_TO_JSVAL(obj);
	return JS_TRUE;
}

JSBool
MFImageAssign(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;
	if (!_standardMFAssign(cx, obj, argc, argv, &rval, &MFImageClass, FIELDTYPE_SFImage)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;
}



/*
static void _setmatrix (JSContext *cx, JSObject *obj, double *matrix) {
	jsval val;
	int i;
	for (i=0; i<16; i++) {

		if (JS_NewNumberValue(cx, matrix[i],&val) == JS_FALSE) {
			printf ("problem creating id matrix\n");
			return;
		}

		if (!JS_SetElement(cx, obj, (jsint) i, &val)) {
			printf( "JS_DefineElement failed for arg %u in VrmlMatrixSetTransform.\n", i);
			return;
		}
	}
}

// get the matrix values into a double array
static void _getmatrix (JSContext *cx, JSObject *obj, double *fl) {
	int32 _length;
	jsval _length_val;
	jsval val;
	int i;
	double d;

	if (!JS_GetProperty(cx, obj,  MF_LENGTH_FIELD, &_length_val)) {
		printf( "JS_GetProperty failed for \"%s\" in _getmatrix.\n", MF_LENGTH_FIELD);
		_length = 0;
	} else {
		_length = JSVAL_TO_INT(_length_val);
	}

	#ifdef JSVRMLCLASSESVERBOSE
	printf ("_getmatrix, length %d\n",_length);
	#endif


	if (_length>16) _length = 16;

	for (i = 0; i < _length; i++) {
		if (!JS_GetElement(cx, obj, (jsint) i, &val)) {
			printf( "failed in get of copyElements index %d.\n", i);
			fl[i] = 0.0;
		} else {
			if (!JS_ValueToNumber(cx, val, &d)) {
				printf ("this is not a mumber!\n");
				fl[i]=0.0;
			} else fl[i]=d;
		}
	}

	// in case our matrix was short for some reason
	for (i=_length; i < 16; i++) {
		fl[i]=0.0;
	}
}
// get rows; used for scale and rot in getTransform
void _get4f(double* ret, double* mat, int row) {
	if (row == 0) { ret[0] = MAT00; ret[1] = MAT01; ret[2] = MAT02; ret[3] = MAT03; }
	if (row == 1) { ret[0] = MAT10; ret[1] = MAT11; ret[2] = MAT12; ret[3] = MAT13; }
	if (row == 2) { ret[0] = MAT20; ret[1] = MAT21; ret[2] = MAT22; ret[3] = MAT23; }
}

// set rows; used for scale and rot in getTransform
void _set4f(double len, double* mat, int row) {
	if (row == 0) { MAT00 = MAT00 / len; MAT01 = MAT01 / len; MAT02 = MAT02 / len; MAT03 = MAT03 / len; }
	if (row == 1) { MAT10 = MAT10 / len; MAT11 = MAT11 / len; MAT12 = MAT12 / len; MAT13 = MAT13 / len; }
	if (row == 2) { MAT20 = MAT20 / len; MAT21 = MAT21 / len; MAT22 = MAT22 / len; MAT23 = MAT23 / len; }
}
*/


// VrmlMatrix 

JSBool
VrmlMatrixToString(JSContext *cx, uintN argc, jsval *vp) {
	return X3DMatrix4ToString(cx, argc, vp);
}
JSBool
VrmlMatrixgetTransform(JSContext *cx, uintN argc, jsval *vp) {
	return X3DMatrix4getTransform(cx, argc, vp);
}
JSBool
VrmlMatrixsetTransform(JSContext *cx, uintN argc, jsval *vp) {
	return X3DMatrix4setTransform(cx, argc, vp);
}
JSBool
VrmlMatrixinverse(JSContext *cx, uintN argc, jsval *vp) {
	return X3DMatrix4inverse(cx, argc, vp);
}
JSBool
VrmlMatrixtranspose(JSContext *cx, uintN argc, jsval *vp) {
	return X3DMatrix4transpose(cx, argc, vp);
}
JSBool
VrmlMatrixmultLeft(JSContext *cx, uintN argc, jsval *vp) {
	return X3DMatrix4multLeft(cx, argc, vp);
}
JSBool
VrmlMatrixmultRight(JSContext *cx, uintN argc, jsval *vp) {
	return X3DMatrix4multRight(cx, argc, vp);
}
JSBool
VrmlMatrixmultVecMatrix(JSContext *cx, uintN argc, jsval *vp) {
	return X3DMatrix4multVecMatrix(cx, argc, vp);
}
JSBool
VrmlMatrixmultMatrixVec(JSContext *cx, uintN argc, jsval *vp) {
	return X3DMatrix4multMatrixVec(cx, argc, vp);
}
JSBool
VrmlMatrixAssign(JSContext *cx, uintN argc, jsval *vp) {
	return X3DMatrix4Assign(cx, argc, vp);
 }

JSBool
VrmlMatrixConstr(JSContext *cx, uintN argc, jsval *vp) {
	return X3DMatrix4Constr(cx, argc, vp);
}
JSBool
VrmlMatrixAddProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid,  JS::MutableHandle<JS::Value> hvp){
	return X3DMatrix4AddProperty(cx, hobj, hiid, hvp);
}
JSBool
VrmlMatrixGetProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid,  JS::MutableHandle<JS::Value> hvp){
	return X3DMatrix4GetProperty(cx, hobj, hiid, hvp);
}
JSBool
VrmlMatrixSetProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JSBool strict, JS::MutableHandle<JS::Value> hvp){
	return X3DMatrix4SetProperty(cx, hobj, hiid, strict, hvp);
}

// MFRotation
JSBool
MFRotationAddProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid,  JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();
	jsval *vp = hvp.address();

	return doMFAddProperty(cx, obj, id, vp,"MFRotationAddProperty");
}

JSBool
MFRotationGetProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid,  JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();
	jsval *vp = hvp.address();

	return _standardMFGetProperty(cx, obj, id, vp,
			 "_FreeWRL_Internal = new SFRotation()",FIELDTYPE_MFRotation);
}

JSBool
MFRotationSetProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JSBool strict, JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();
	jsval *vp = hvp.address();

	return doMFSetProperty(cx, obj, id, vp,FIELDTYPE_MFRotation);
}

JSBool
MFRotationToString(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_THIS_OBJECT(cx,vp);
        jsval *argv = JS_ARGV(cx,vp);
        jsval rval;

	UNUSED(argc);
	UNUSED(argv);
	if (!doMFToString(cx, obj, "MFRotation", &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx,vp,rval);
	return JS_TRUE;

}

JSBool
MFRotationConstr(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_NewObject(cx,&MFRotationClass,NULL,NULL);
        jsval *argv = JS_ARGV(cx,vp);
	jsval rval = OBJECT_TO_JSVAL(obj);
	if (!MFRotationConstrInternals(cx,obj,argc,argv,&rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx,vp,rval);
	return JS_TRUE;
}
JSBool MFRotationConstrInternals(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval) {

	JSObject *_arrayObj;
	int isArray;
	JSObject *_obj;
	unsigned int i;
	union anyVrml *anyv;

	ADD_ROOT(cx,obj)

	isArray = FALSE;
	if(argc == 1 && argv){
		//could it be new MFxxx( [A,B] ) javscript array, as used by Carlson aka Carlson Array
		// tests/JohnCarlson/Arc1A.x3d
		if (!JS_ValueToObject(cx, argv[0], &_arrayObj)) {
			printf( "JS_ValueToObject failed in MFVec3fConstr.\n");
			return JS_FALSE;
		}

		if(JS_IsArrayObject(cx, _arrayObj)){
			jsuint lengthp;
			jsval vp;
			//printf("its an array\n");
			isArray = TRUE;
			JS_GetArrayLength(cx,_arrayObj, &lengthp);
			argc = lengthp;
		}
	}

	if(SM_method() == 2){
		AnyNative *any;
		int newsize;
		if((any = (AnyNative*)AnyNativeNew(FIELDTYPE_MFRotation,NULL,NULL)) == NULL){
			printf( "AnyfNativeNew failed in MFRotationConstr.\n");
			return JS_FALSE;
		}
		if (!JS_SetPrivateFw(cx, obj, any)) {
			printf( "JS_SetPrivate failed in MFRotationConstr.\n");
			return JS_FALSE;
		}
		anyv = any->v;
		newsize = sizeof(struct SFRotation)*upper_power_of_two(argc);
		if(argc > 0){
			anyv->mfrotation.p = MALLOC(struct SFRotation*,newsize);
			memset(anyv->mfrotation.p,0,newsize);
		}

	}else{
		DEFINE_LENGTH(cx,obj,argc)
	}

	if (!argv) {
		return JS_TRUE;
	}

	#ifdef JSVRMLCLASSESVERBOSE
		printf("MFRotationConstr: obj = %p, %u args\n", obj, argc);
	#endif
	for (i = 0; i < argc; i++) {
		jsval vp;
		if(isArray){
			JS_GetElement(cx, _arrayObj, i, &vp);

		}else{
			vp = argv[i];
		}
		if (!JS_ValueToObject(cx, vp, &_obj)) {
			printf(
					"JS_ValueToObject failed in MFRotationConstr.\n");
			return JS_FALSE;
		}

		CHECK_CLASS(cx,_obj,NULL,__FUNCTION__,SFRotationClass)
		if(SM_method()==2){
			AnyNative *any2;
			if((any2 = (AnyNative *)JS_GetPrivateFw(cx,_obj)) != NULL){
				if(any2->type == FIELDTYPE_SFRotation ){
					shallow_copy_field(FIELDTYPE_SFRotation,any2->v,(union anyVrml*)&anyv->mfrotation.p[i]);
					anyv->mfrotation.n = i+1;
				}
			}
			// else for now we'll leave zeros
		}else{
			if (!JS_DefineElement(cx, obj, (jsint) i, vp, JS_GET_PROPERTY_STUB, JS_SET_PROPERTY_CHECK, JSPROP_ENUMERATE)) {
				printf( "JS_DefineElement failed for arg %d in MFRotationConstr.\n", i);
				return JS_FALSE;
			}
		}
	}
	*rval = OBJECT_TO_JSVAL(obj);
	return JS_TRUE;
}

JSBool
MFRotationAssign(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_THIS_OBJECT(cx,vp);
        jsval *argv = JS_ARGV(cx,vp);
        jsval rval;

	if (!_standardMFAssign (cx, obj, argc, argv, &rval, &MFRotationClass,FIELDTYPE_SFRotation)) { return JS_FALSE; }
	JS_SET_RVAL(cx,vp,rval);
	return JS_TRUE;

}

// MFStrings 
JSBool
MFStringAddProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid,  JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid iid = *hiid.address();
	jsval *vp = hvp.address();
	jsval id;
	if (!JS_IdToValue(cx,iid,&id)) {
		printf("JS_IdToValue failed in MFStringAddProperty\n");
		return JS_FALSE;
	}


	#ifdef JSVRMLCLASSESVERBOSE
	printf("MFStringAddProperty: vp = %p\n", obj);
                if (JSVAL_IS_STRING(*vp)==TRUE) {
		printf("	is a common string :%s:\n",
#if JS_VERSION < 185
                        JS_GetStringBytes(JS_ValueToString(cx, *vp)));
#else
                        JS_EncodeString(cx,JS_ValueToString(cx, *vp)));
#endif
                }
                if (JSVAL_IS_OBJECT(*vp)==TRUE) {
                        printf ("       parameter is an object\n");
                }
                if (JSVAL_IS_PRIMITIVE(*vp)==TRUE) {
                        printf ("       parameter is a primitive\n");
                }
		if (JSVAL_IS_NULL(*vp)) { printf ("	- its a NULL\n");}
		if (JSVAL_IS_INT(*vp)) { printf ("	- its a INT %d\n",JSVAL_TO_INT(*vp));}

		printf("MFStringAddProperty: id = %p\n", obj);
                if (JSVAL_IS_STRING(id)==TRUE) {
		printf("	is a common string :%s:\n",
#if JS_VERSION < 185
                        JS_GetStringBytes(JS_ValueToString(cx, id)));
#else
                        JS_EncodeString(cx,JS_ValueToString(cx, id)));
#endif
                }
                if (JSVAL_IS_OBJECT(id)==TRUE) {
                        printf ("       parameter is an object\n");
                }
                if (JSVAL_IS_PRIMITIVE(id)==TRUE) {
                        printf ("       parameter is a primitive\n");
                }
		if (JSVAL_IS_NULL(id)) { printf ("	- its a NULL\n");}
		if (JSVAL_IS_INT(id)) { printf ("	- its a INT %d\n",JSVAL_TO_INT(id));}

	#endif


	/* unquote parts of vp string if necessary */
	if (JSVAL_IS_STRING(*vp)) {
		if (!doMFStringUnquote(cx, vp)) {
			printf(
				"doMFStringUnquote failed in MFStringAddProperty.\n");
			return JS_FALSE;
		}
	}
	return doMFAddProperty(cx, obj, iid, vp,"MFStringAddProperty");

}


JSBool
MFStringGetProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid,  JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid iid = *hiid.address();
	jsval *vp = hvp.address();


	JSString *_str;
	int32 _length, _index;
    jsval _length_val;

	jsval id;
	if (!JS_IdToValue(cx,iid,&id)) {
		printf("JS_IdToValue failed in MFStringGetProperty\n");
		return JS_FALSE;
	}

	if(SM_method()==2){
		return _standardMFGetProperty(cx, obj, iid, vp,
			 "_FreeWRL_Internal = new SFString()",FIELDTYPE_MFString);

	}

	#ifdef JSVRMLCLASSESVERBOSE
	printf("MFStringGetProperty: obj = %p\n", obj);
	#endif

    if (!JS_GetProperty(cx, obj,  MF_LENGTH_FIELD, &_length_val)) {
		printf( "JS_GetProperty failed for \"%s\" in MFStringGetProperty.\n", MF_LENGTH_FIELD);
        return JS_FALSE;
	}
	_length = JSVAL_TO_INT(_length_val);

	if (JSVAL_IS_INT(id)) {
		_index = JSVAL_TO_INT(id);

		if (_index >= _length) {
			_str = JS_NewStringCopyZ(cx, "");
			*vp = STRING_TO_JSVAL(_str);
			if (!JS_DefineElement(cx, obj, (jsint) _index, *vp, JS_GET_PROPERTY_STUB, JS_SET_PROPERTY_CHECK, JSPROP_ENUMERATE)) {
				printf( "JS_DefineElement failed in MFStringGetProperty.\n");
				return JS_FALSE;
			}
		} else {
			if (!JS_LookupElement(cx, obj, _index, vp)) {
				printf( "JS_LookupElement failed in MFStringGetProperty.\n");
				return JS_FALSE;
			}
			if (JSVAL_IS_NULL(*vp)) {
				/* jut make up new strings, as above */
				/* printf ("MFStringGetProperty, element %d is JSVAL_VOID, making up string for it\n",_index); */
				_str = JS_NewStringCopyZ(cx, "NULL");
				*vp = STRING_TO_JSVAL(_str);
				if (!JS_DefineElement(cx, obj, (jsint) _index, *vp, JS_GET_PROPERTY_STUB, JS_SET_PROPERTY_CHECK, JSPROP_ENUMERATE)) {
					printf( "JS_DefineElement failed in MFStringGetProperty.\n");
					return JS_FALSE;
				}
			}
		}
	}

	return JS_TRUE;
}

JSBool
MFStringSetProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JSBool strict, JS::MutableHandle<JS::Value> hvp){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();
	jsval *vp = hvp.address();

	JSBool rv;

	#ifdef JSVRMLCLASSESVERBOSE
	printf("MFStringSetProperty: obj = %p id %d jsval %u\n", obj, id, (unsigned int)*vp);

printf ("MFStringSetProperty, setting vp of type...\n");
		if (JSVAL_IS_OBJECT(*vp)) { printf ("	- MFStringSetProperty, vp is a OBJECT\n");}
		if (JSVAL_IS_PRIMITIVE(*vp)) { printf ("	- MFStringSetProperty, vp is a PRIMITIVE\n");}
		if (JSVAL_IS_NULL(*vp)) { printf ("	- MFStringSetProperty, vp is a NULL\n");}
		if (JSVAL_IS_STRING(*vp)) { printf ("	- MFStringSetProperty, vp is a STRING\n");}
		if (JSVAL_IS_INT(*vp)) { printf ("	- MFStringSetProperty, vp is a INT %d\n",JSVAL_TO_INT(*vp));}

	#endif


	/* unquote parts of vp string if necessary */
	if (JSVAL_IS_STRING(*vp)) {
		if (!doMFStringUnquote(cx, vp)) {
			printf(
				"doMFStringUnquote failed in MFStringSetProperty.\n");
			return JS_FALSE;
		}
	}
	rv = doMFSetProperty(cx, obj, id, vp,FIELDTYPE_MFString);
	#ifdef JSVRMLCLASSESVERBOSE
	printf ("returning from MFStringSetProperty\n");
	#endif

	return rv;

}

JSBool
MFStringToString(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_THIS_OBJECT(cx,vp);
        jsval *argv = JS_ARGV(cx,vp);
        jsval rval;

	UNUSED(argc);
	UNUSED(argv);
	#ifdef JSVRMLCLASSESVERBOSE
	printf("MFStringToString: obj = %p, %u args\n", obj, argc);
	#endif


	if (!doMFToString(cx, obj, "MFString", &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx,vp,rval);
	return JS_TRUE;

}


JSBool
MFStringConstr(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_NewObject(cx,&MFStringClass,NULL,NULL);
        jsval *argv = JS_ARGV(cx,vp);
        jsval rval = OBJECT_TO_JSVAL(obj);
        if (!MFStringConstrInternals(cx,obj,argc,argv,&rval)) { return JS_FALSE; }
        JS_SET_RVAL(cx,vp,rval);
        return JS_TRUE;
}
JSBool MFStringConstrInternals(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval) {

	JSObject *_arrayObj;
	int isArray;

	unsigned int i;
	union anyVrml *anyv;

	#ifdef JSVRMLCLASSESVERBOSE
	JSString *_str;
	printf("MFStringConstr: cx %p, obj %p args %d rval %p parent %p... ", cx, obj, argc, rval, JS_GetParent(cx, obj));
	#endif

	ADD_ROOT(cx,obj)

	isArray = FALSE;
	if(argc == 1 && argv){
		//could it be new MFxxx( [A,B] ) javscript array, as used by Carlson aka Carlson Array
		// tests/JohnCarlson/Arc1A.x3d
		if (!JS_ValueToObject(cx, argv[0], &_arrayObj)) {
			printf( "JS_ValueToObject failed in MFVec3fConstr.\n");
			return JS_FALSE;
		}

		if(JS_IsArrayObject(cx, _arrayObj)){
			jsuint lengthp;
			jsval vp;
			//printf("its an array\n");
			isArray = TRUE;
			JS_GetArrayLength(cx,_arrayObj, &lengthp);
			argc = lengthp;
		}
	}

	if(SM_method() == 2){
		AnyNative *any;
		int newsize;
		if((any = (AnyNative*)AnyNativeNew(FIELDTYPE_MFString,NULL,NULL)) == NULL){
			printf( "AnyfNativeNew failed in MFStringConstr.\n");
			return JS_FALSE;
		}
		if (!JS_SetPrivateFw(cx, obj, any)) {
			printf( "JS_SetPrivate failed in MFStringConstr.\n");
			return JS_FALSE;
		}
		anyv = any->v;
		newsize = sizeof(struct Uni_String*)*upper_power_of_two(argc);
		if(argc > 0){
			anyv->mfstring.p = MALLOC(struct Uni_String**,newsize);
			memset(anyv->mfstring.p,0,newsize);
		}

	}else{
		DEFINE_LENGTH(cx,obj,argc)
		DEFINE_MF_ECMA_HAS_CHANGED
	}

	if (!argv) {
		return JS_TRUE;
	}

	for (i = 0; i < argc; i++) {
		jsval vp;
		if(isArray){
			JS_GetElement(cx, _arrayObj, i, &vp);

		}else{
			vp = argv[i];
		}
		#ifdef JSVRMLCLASSESVERBOSE
	  	printf ("argv %d is a ...",i);

		if (JSVAL_IS_STRING(argv[i])==TRUE) {
        	        printf (" Common String, is");
			_str = JS_ValueToString(cx, argv[i]);
#if JS_VERSION < 185
			printf (" %s",JS_GetStringBytes(_str));
#else
			printf (" %s",JS_EncodeString(cx,_str));
#endif
			printf ("..");
		
	        }                                          
		if (JSVAL_IS_OBJECT(argv[i])==TRUE) {   
	                printf (" is an object");
	        }                       
		if (JSVAL_IS_PRIMITIVE(argv[i])==TRUE) {
        	        printf (" is a primitive");
        	}

		if ((_str = JS_ValueToString(cx, argv[i])) == NULL) {
			printf( "JS_ValueToString failed in MFStringConstr.");
			return JS_FALSE;
		}
		printf ("\n");
		#endif

		if(SM_method()==2){
			char *cstring = NULL;
			if (JSVAL_IS_STRING(vp)==TRUE) {
				// https://developer.mozilla.org/en-US/docs/Mozilla/Projects/SpiderMonkey/JSAPI_reference/JS_EncodeString
				// cstring: we own it
				JSString *_str;
				_str = JS_ValueToString(cx, vp);
				cstring = JS_EncodeString(cx,_str); //if utf16: lossy - will drop first byte, garbage
				//JS_free(cx,_str); bombs if I do this

			}else{
				//could try and convert object or ecma primitive to string via toString()
			}
			if(cstring){
				//newASCIIString does an extra malloc
				struct Uni_String *us;
				us = MALLOC(struct Uni_String*,sizeof(struct Uni_String));
				us->strptr = cstring;
				us->len = strlen(cstring);
				us->touched = 0;
				anyv->mfstring.p[i] = us;
				anyv->mfstring.n = i+1;
			}
			// else for now we'll leave zeros
		}else{
			if (!JS_DefineElement(cx, obj, (jsint) i, vp, JS_GET_PROPERTY_STUB, JS_SET_PROPERTY_CHECK, JSPROP_ENUMERATE)) {
				printf( "JS_DefineElement failed for arg %d in MFStringConstr.\n", i);
				return JS_FALSE;
			}
		}
	}
	*rval = OBJECT_TO_JSVAL(obj);

	#ifdef JSVRMLCLASSESVERBOSE
	printf ("finished MFStringConstr\n");
	#endif

	return JS_TRUE;
}

JSBool
MFStringAssign(JSContext *cx, uintN argc, jsval *vp) {
        JSObject *obj = JS_THIS_OBJECT(cx,vp);
        jsval *argv = JS_ARGV(cx,vp);
        jsval rval;


	#ifdef JSVRMLCLASSESVERBOSE
	printf("MFStringAssign: obj = %p args %d... ", obj, argc);
	#endif
	if(SM_method() != 2){
		SET_MF_ECMA_HAS_CHANGED
	}

	if (!_standardMFAssign (cx, obj, argc, argv, &rval, &MFStringClass,FIELDTYPE_SFString)) { return JS_FALSE; }
	JS_SET_RVAL(cx,vp,OBJECT_TO_JSVAL(obj));
	return JS_TRUE;

}

/* testing.. */
JSBool MFStringDeleteProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid,  JSBool *succeeded){
	JSObject *obj = *hobj.address();
	jsid iid = *hiid.address();

	#ifdef JSVRMLCLASSESVERBOSE
	printf ("MFStringDeleteProperty\n"); 
	#endif
	return JS_TRUE;
}
JSBool
MFStringEnumerateProperty(JSContext *cx, JS::Handle<JSObject*> hobj) {
	JSObject *obj = *hobj.address();

	#ifdef JSVRMLCLASSESVERBOSE
	printf ("MFStringEnumerateProperty\n"); 
	#endif
	return JS_TRUE;
}

JSBool MFStringResolveProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid){
	JSObject *obj = *hobj.address();
	jsid id = *hiid.address();

	#ifdef JSVRMLCLASSESVERBOSE
	printf ("MFStringResolveProperty\n"); 
	#endif
	return JS_TRUE;
}
JSBool MFStringConvertProperty(JSContext *cx, JS::Handle<JSObject*> hobj, JSType type, JS::MutableHandle<JS::Value> hvp) {
	JSObject *obj = *hobj.address();
	jsval *vp = hvp.address();


	#ifdef JSVRMLCLASSESVERBOSE
	printf ("MFStringConvertProperty\n"); 
	#endif
	return JS_TRUE;
}

// MFMatrix3f

JSBool
MFMatrix3fAddProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();
	return doMFAddProperty(cx, obj, id, vp, "MFMatrix3fAddProperty");
}

JSBool
MFMatrix3fGetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

	return _standardMFGetProperty(cx, obj, id, vp,
		"_FreeWRL_Internal = new SFMatrix3f()", FIELDTYPE_MFMatrix3f);
}

JSBool
MFMatrix3fSetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JSBool strict, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

	return doMFSetProperty(cx, obj, id, vp, FIELDTYPE_MFMatrix3f);
}

JSBool
MFMatrix3fToString(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;

	UNUSED(argc);
	UNUSED(argv);
	/* printf ("CALLED MFMatrix3fToString\n");*/
	if (!doMFToString(cx, obj, "MFMatrix3f", &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;

}

JSBool
MFMatrix3fConstr(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_NewObject(cx, &MFMatrix3fClass, NULL, NULL);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval = OBJECT_TO_JSVAL(obj);
	if (!MFMatrix3fConstrInternals(cx, obj, argc, argv, &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;
}
JSBool MFMatrix3fConstrInternals(JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval) {

	JSObject* _arrayObj;
	int isArray;
	JSObject* _obj;
	unsigned int i;
	union anyVrml* anyv;

	ADD_ROOT(cx, obj)

	isArray = FALSE;
	if (argc == 1 && argv) {
		//could it be new MFxxx( [A,B] ) javscript array, as used by Carlson aka Carlson Array
		// tests/JohnCarlson/Arc1A.x3d
		if (!JS_ValueToObject(cx, argv[0], &_arrayObj)) {
			printf("JS_ValueToObject failed in MFMatrix3fConstr.\n");
			return JS_FALSE;
		}

		if (JS_IsArrayObject(cx, _arrayObj)) {
			jsuint lengthp;
			jsval vp;
			//printf("its an array\n");
			isArray = TRUE;
			JS_GetArrayLength(cx, _arrayObj, &lengthp);
			argc = lengthp;
		}
	}



	if (SM_method() == 2) {
		AnyNative* any;
		int newsize;
		if ((any = (AnyNative*)AnyNativeNew(FIELDTYPE_MFMatrix3f, NULL, NULL)) == NULL) {
			printf("AnyfNativeNew failed in MFMatrix3fConstr.\n");
			return JS_FALSE;
		}
		if (!JS_SetPrivateFw(cx, obj, any)) {
			printf("JS_SetPrivate failed in MFMatrix3fConstr.\n");
			return JS_FALSE;
		}
		anyv = any->v;
		newsize = sizeof(struct SFMatrix3f) * upper_power_of_two(argc);
		if (argc > 0) {
			anyv->mfmatrix3f.p = MALLOC(struct SFMatrix3f*, newsize);
			memset(anyv->mfmatrix3f.p, 0, newsize);
		}

	}
	else {
		DEFINE_LENGTH(cx, obj, argc)
	}
	if (!argv) {
		return JS_TRUE;
	}

#ifdef JSVRMLCLASSESVERBOSE
	printf("MFVec4dConstr: obj = %p, %u args\n", obj, argc);
#endif	
	for (i = 0; i < argc; i++) {
		jsval vp;
		if (isArray) {
			JS_GetElement(cx, _arrayObj, i, &vp);

		}
		else {
			vp = argv[i];
		}
		if (!JS_ValueToObject(cx, vp, &_obj)) {
			printf("JS_ValueToObject failed in MFMatrix3fConstr.\n");
			return JS_FALSE;
		}

		//CHECK_CLASS(cx, _obj, NULL, __FUNCTION__, SFMatrix3fClass)

		if (SM_method() == 2) {
			AnyNative* any2;
			if ((any2 = (AnyNative*)JS_GetPrivateFw(cx, _obj)) != NULL) {
				//2018 I think as long as its 3+ contiguous floats, we can use it as a vec2f, 
				// but in future internal types might change
				if (any2->type == FIELDTYPE_SFMatrix3f) {
					shallow_copy_field(FIELDTYPE_SFMatrix3f, any2->v, (union anyVrml*)&anyv->mfmatrix3f.p[i]);
					anyv->mfmatrix3f.n = i + 1;
				}
				else {
					shallow_copy_field_precision(any2->type, FIELDTYPE_SFMatrix3f, any2->v, (union anyVrml*)&anyv->mfmatrix3f.p[i]);
					anyv->mfmatrix3f.n = i + 1;
				}
			}
			// else for now we'll leave zeros
		}
	}
	*rval = OBJECT_TO_JSVAL(obj);
	return JS_TRUE;
}

JSBool
MFMatrix3fAssign(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;
	if (!_standardMFAssign(cx, obj, argc, argv, &rval, &MFMatrix3fClass, FIELDTYPE_SFMatrix3f)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;
}

// MFMatrix4f 


JSBool
MFMatrix4fAddProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();
	return doMFAddProperty(cx, obj, id, vp, "MFMatrix4fAddProperty");
}

JSBool
MFMatrix4fGetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

	return _standardMFGetProperty(cx, obj, id, vp,
		"_FreeWRL_Internal = new SFMatrix4f()", FIELDTYPE_MFMatrix4f);
}

JSBool
MFMatrix4fSetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JSBool strict, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

	return doMFSetProperty(cx, obj, id, vp, FIELDTYPE_MFMatrix4f);
}

JSBool
MFMatrix4fToString(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;

	UNUSED(argc);
	UNUSED(argv);
	/* printf ("CALLED MFMatrix4fToString\n");*/
	if (!doMFToString(cx, obj, "MFMatrix4f", &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;

}

JSBool
MFMatrix4fConstr(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_NewObject(cx, &MFMatrix4fClass, NULL, NULL);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval = OBJECT_TO_JSVAL(obj);
	if (!MFMatrix4fConstrInternals(cx, obj, argc, argv, &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;
}
JSBool MFMatrix4fConstrInternals(JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval) {

	JSObject* _arrayObj;
	int isArray;
	JSObject* _obj;
	unsigned int i;
	union anyVrml* anyv;

	ADD_ROOT(cx, obj)

		isArray = FALSE;
	if (argc == 1 && argv) {
		//could it be new MFxxx( [A,B] ) javscript array, as used by Carlson aka Carlson Array
		// tests/JohnCarlson/Arc1A.x3d
		if (!JS_ValueToObject(cx, argv[0], &_arrayObj)) {
			printf("JS_ValueToObject failed in MFMatrix4fConstr.\n");
			return JS_FALSE;
		}

		if (JS_IsArrayObject(cx, _arrayObj)) {
			jsuint lengthp;
			jsval vp;
			//printf("its an array\n");
			isArray = TRUE;
			JS_GetArrayLength(cx, _arrayObj, &lengthp);
			argc = lengthp;
		}
	}



	if (SM_method() == 2) {
		AnyNative* any;
		int newsize;
		if ((any = (AnyNative*)AnyNativeNew(FIELDTYPE_MFMatrix4f, NULL, NULL)) == NULL) {
			printf("AnyfNativeNew failed in MFMatrix4fConstr.\n");
			return JS_FALSE;
		}
		if (!JS_SetPrivateFw(cx, obj, any)) {
			printf("JS_SetPrivate failed in MFMatrix4fConstr.\n");
			return JS_FALSE;
		}
		anyv = any->v;
		newsize = sizeof(struct SFMatrix4f) * upper_power_of_two(argc);
		if (argc > 0) {
			anyv->mfmatrix4f.p = MALLOC(struct SFMatrix4f*, newsize);
			memset(anyv->mfmatrix4f.p, 0, newsize);
		}

	}
	else {
		DEFINE_LENGTH(cx, obj, argc)
	}
	if (!argv) {
		return JS_TRUE;
	}

#ifdef JSVRMLCLASSESVERBOSE
	printf("MFVec4dConstr: obj = %p, %u args\n", obj, argc);
#endif	
	for (i = 0; i < argc; i++) {
		jsval vp;
		if (isArray) {
			JS_GetElement(cx, _arrayObj, i, &vp);

		}
		else {
			vp = argv[i];
		}
		if (!JS_ValueToObject(cx, vp, &_obj)) {
			printf("JS_ValueToObject failed in MFMatrix4fConstr.\n");
			return JS_FALSE;
		}

		//CHECK_CLASS(cx, _obj, NULL, __FUNCTION__, SFMatrix4fClass)

		if (SM_method() == 2) {
			AnyNative* any2;
			if ((any2 = (AnyNative*)JS_GetPrivateFw(cx, _obj)) != NULL) {
				//2018 I think as long as its 3+ contiguous floats, we can use it as a vec2f, 
				// but in future internal types might change
				if (any2->type == FIELDTYPE_SFMatrix4f) {
					shallow_copy_field(FIELDTYPE_SFMatrix4f, any2->v, (union anyVrml*)&anyv->mfmatrix4f.p[i]);
					anyv->mfmatrix4f.n = i + 1;
				}
				else {
					shallow_copy_field_precision(any2->type, FIELDTYPE_SFMatrix4f, any2->v, (union anyVrml*)&anyv->mfmatrix4f.p[i]);
					anyv->mfmatrix4f.n = i + 1;
				}
			}
			// else for now we'll leave zeros
		}
	}
	*rval = OBJECT_TO_JSVAL(obj);
	return JS_TRUE;
}

JSBool
MFMatrix4fAssign(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;
	if (!_standardMFAssign(cx, obj, argc, argv, &rval, &MFMatrix4fClass, FIELDTYPE_SFMatrix4f)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;
}

// MFMatrix3d 

JSBool
MFMatrix3dAddProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();
	return doMFAddProperty(cx, obj, id, vp, "MFMatrix3dAddProperty");
}

JSBool
MFMatrix3dGetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

	return _standardMFGetProperty(cx, obj, id, vp,
		"_FreeWRL_Internal = new SFMatrix3d()", FIELDTYPE_MFMatrix3d);
}

JSBool
MFMatrix3dSetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JSBool strict, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

	return doMFSetProperty(cx, obj, id, vp, FIELDTYPE_MFMatrix3d);
}

JSBool
MFMatrix3dToString(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;

	UNUSED(argc);
	UNUSED(argv);
	/* printf ("CALLED MFMatrix3dToString\n");*/
	if (!doMFToString(cx, obj, "MFMatrix3d", &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;

}

JSBool
MFMatrix3dConstr(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_NewObject(cx, &MFMatrix3dClass, NULL, NULL);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval = OBJECT_TO_JSVAL(obj);
	if (!MFMatrix3dConstrInternals(cx, obj, argc, argv, &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;
}
JSBool MFMatrix3dConstrInternals(JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval) {

	JSObject* _arrayObj;
	int isArray;
	JSObject* _obj;
	unsigned int i;
	union anyVrml* anyv;

	ADD_ROOT(cx, obj)

		isArray = FALSE;
	if (argc == 1 && argv) {
		//could it be new MFxxx( [A,B] ) javscript array, as used by Carlson aka Carlson Array
		// tests/JohnCarlson/Arc1A.x3d
		if (!JS_ValueToObject(cx, argv[0], &_arrayObj)) {
			printf("JS_ValueToObject failed in MFMatrix3dConstr.\n");
			return JS_FALSE;
		}

		if (JS_IsArrayObject(cx, _arrayObj)) {
			jsuint lengthp;
			jsval vp;
			//printf("its an array\n");
			isArray = TRUE;
			JS_GetArrayLength(cx, _arrayObj, &lengthp);
			argc = lengthp;
		}
	}



	if (SM_method() == 2) {
		AnyNative* any;
		int newsize;
		if ((any = (AnyNative*)AnyNativeNew(FIELDTYPE_MFMatrix3d, NULL, NULL)) == NULL) {
			printf("AnyfNativeNew failed in MFMatrix3dConstr.\n");
			return JS_FALSE;
		}
		if (!JS_SetPrivateFw(cx, obj, any)) {
			printf("JS_SetPrivate failed in MFMatrix3dConstr.\n");
			return JS_FALSE;
		}
		anyv = any->v;
		newsize = sizeof(struct SFMatrix3d) * upper_power_of_two(argc);
		if (argc > 0) {
			anyv->mfmatrix3d.p = MALLOC(struct SFMatrix3d*, newsize);
			memset(anyv->mfmatrix3d.p, 0, newsize);
		}

	}
	else {
		DEFINE_LENGTH(cx, obj, argc)
	}
	if (!argv) {
		return JS_TRUE;
	}

#ifdef JSVRMLCLASSESVERBOSE
	printf("MFVec4dConstr: obj = %p, %u args\n", obj, argc);
#endif	
	for (i = 0; i < argc; i++) {
		jsval vp;
		if (isArray) {
			JS_GetElement(cx, _arrayObj, i, &vp);

		}
		else {
			vp = argv[i];
		}
		if (!JS_ValueToObject(cx, vp, &_obj)) {
			printf("JS_ValueToObject failed in MFMatrix3dConstr.\n");
			return JS_FALSE;
		}

		//CHECK_CLASS(cx, _obj, NULL, __FUNCTION__, SFMatrix3dClass)

		if (SM_method() == 2) {
			AnyNative* any2;
			if ((any2 = (AnyNative*)JS_GetPrivateFw(cx, _obj)) != NULL) {
				//2018 I think as long as its 3+ contiguous floats, we can use it as a vec2f, 
				// but in future internal types might change
				if (any2->type == FIELDTYPE_SFMatrix3d) {
					shallow_copy_field(FIELDTYPE_SFMatrix3d, any2->v, (union anyVrml*)&anyv->mfmatrix3d.p[i]);
					anyv->mfmatrix3d.n = i + 1;
				}
				else {
					shallow_copy_field_precision(any2->type, FIELDTYPE_SFMatrix3d, any2->v, (union anyVrml*)&anyv->mfmatrix3d.p[i]);
					anyv->mfmatrix3d.n = i + 1;
				}
			}
			// else for now we'll leave zeros
		}
	}
	*rval = OBJECT_TO_JSVAL(obj);
	return JS_TRUE;
}

JSBool
MFMatrix3dAssign(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;
	if (!_standardMFAssign(cx, obj, argc, argv, &rval, &MFMatrix3dClass, FIELDTYPE_SFMatrix3d)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;
}

// MFMatrix4d


JSBool
MFMatrix4dAddProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();
	return doMFAddProperty(cx, obj, id, vp, "MFMatrix4dAddProperty");
}

JSBool
MFMatrix4dGetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

	return _standardMFGetProperty(cx, obj, id, vp,
		"_FreeWRL_Internal = new SFMatrix4d()", FIELDTYPE_MFMatrix4d);
}

JSBool
MFMatrix4dSetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JSBool strict, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();

	return doMFSetProperty(cx, obj, id, vp, FIELDTYPE_MFMatrix4d);
}

JSBool
MFMatrix4dToString(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;

	UNUSED(argc);
	UNUSED(argv);
	/* printf ("CALLED MFMatrix4dToString\n");*/
	if (!doMFToString(cx, obj, "MFMatrix4d", &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;

}

JSBool
MFMatrix4dConstr(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_NewObject(cx, &MFMatrix4dClass, NULL, NULL);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval = OBJECT_TO_JSVAL(obj);
	if (!MFMatrix4dConstrInternals(cx, obj, argc, argv, &rval)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;
}
JSBool MFMatrix4dConstrInternals(JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval) {

	JSObject* _arrayObj;
	int isArray;
	JSObject* _obj;
	unsigned int i;
	union anyVrml* anyv;

	ADD_ROOT(cx, obj)

		isArray = FALSE;
	if (argc == 1 && argv) {
		//could it be new MFxxx( [A,B] ) javscript array, as used by Carlson aka Carlson Array
		// tests/JohnCarlson/Arc1A.x3d
		if (!JS_ValueToObject(cx, argv[0], &_arrayObj)) {
			printf("JS_ValueToObject failed in MFMatrix4dConstr.\n");
			return JS_FALSE;
		}

		if (JS_IsArrayObject(cx, _arrayObj)) {
			jsuint lengthp;
			jsval vp;
			//printf("its an array\n");
			isArray = TRUE;
			JS_GetArrayLength(cx, _arrayObj, &lengthp);
			argc = lengthp;
		}
	}



	if (SM_method() == 2) {
		AnyNative* any;
		int newsize;
		if ((any = (AnyNative*)AnyNativeNew(FIELDTYPE_MFMatrix4d, NULL, NULL)) == NULL) {
			printf("AnyfNativeNew failed in MFMatrix4dConstr.\n");
			return JS_FALSE;
		}
		if (!JS_SetPrivateFw(cx, obj, any)) {
			printf("JS_SetPrivate failed in MFMatrix4dConstr.\n");
			return JS_FALSE;
		}
		anyv = any->v;
		newsize = sizeof(struct SFMatrix4d) * upper_power_of_two(argc);
		if (argc > 0) {
			anyv->mfmatrix4d.p = MALLOC(struct SFMatrix4d*, newsize);
			memset(anyv->mfmatrix4d.p, 0, newsize);
		}

	}
	else {
		DEFINE_LENGTH(cx, obj, argc)
	}
	if (!argv) {
		return JS_TRUE;
	}

#ifdef JSVRMLCLASSESVERBOSE
	printf("MFVec4dConstr: obj = %p, %u args\n", obj, argc);
#endif	
	for (i = 0; i < argc; i++) {
		jsval vp;
		if (isArray) {
			JS_GetElement(cx, _arrayObj, i, &vp);

		}
		else {
			vp = argv[i];
		}
		if (!JS_ValueToObject(cx, vp, &_obj)) {
			printf("JS_ValueToObject failed in MFMatrix4dConstr.\n");
			return JS_FALSE;
		}

		//CHECK_CLASS(cx, _obj, NULL, __FUNCTION__, SFMatrix4dClass)

		if (SM_method() == 2) {
			AnyNative* any2;
			if ((any2 = (AnyNative*)JS_GetPrivateFw(cx, _obj)) != NULL) {
				//2018 I think as long as its 3+ contiguous floats, we can use it as a vec2f, 
				// but in future internal types might change
				if (any2->type == FIELDTYPE_SFMatrix4d) {
					shallow_copy_field(FIELDTYPE_SFMatrix4d, any2->v, (union anyVrml*)&anyv->mfmatrix4d.p[i]);
					anyv->mfmatrix4d.n = i + 1;
				}
				else {
					shallow_copy_field_precision(any2->type, FIELDTYPE_SFMatrix4d, any2->v, (union anyVrml*)&anyv->mfmatrix4d.p[i]);
					anyv->mfmatrix4d.n = i + 1;
				}
			}
			// else for now we'll leave zeros
		}
	}
	*rval = OBJECT_TO_JSVAL(obj);
	return JS_TRUE;
}

JSBool
MFMatrix4dAssign(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;
	if (!_standardMFAssign(cx, obj, argc, argv, &rval, &MFMatrix4dClass, FIELDTYPE_SFMatrix4d)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;
}

// X3DMatrix4 (same as VrmlMatrix)

JSBool
X3DMatrix4ToString(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);

	JSString* _str;
	double* cc;
	char buff[STRING];

	UNUSED(argc);
	UNUSED(argv);
	if (SM_method() == 2) {
		AnyNative* ptr;
		if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, obj)) == NULL) {
			printf("JS_GetPrivate failed in SFMatrix4dToString.\n");
			return JS_FALSE;
		}
		cc = ptr->v->sfmatrix4d.c;
	}
	memset(buff, 0, STRING);
	sprintf(buff, "%.9g %.9g %.9g %.9g, %.9g %.9g %.9g %.9g, %.9g %.9g %.9g %.9g, %.9g %.9g %.9g %.9g",
		cc[0], cc[1], cc[2], cc[3],
		cc[4], cc[5], cc[6], cc[7],
		cc[8], cc[9], cc[10], cc[11],
		cc[12], cc[13], cc[14], cc[15]
	);
	_str = JS_NewStringCopyZ(cx, buff);

	JS_SET_RVAL(cx, vp, STRING_TO_JSVAL(_str));
	return JS_TRUE;
}

JSBool
X3DMatrix4getTransform(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	int i;
	JSObject* transObj = NULL;
	JSObject* rotObj = NULL;
	JSObject* scaleObj = NULL;

	struct SFMatrix4d* cptr; 
	struct SFVec3d translation; 
	struct SFRotation rotation; 
	struct SFVec3d scale; 
	double* matrix[4], retscale[3];
	double matrixd[16];
	Quaternion quat;
	double qu[4];


	AnyNative* ptr;
	if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, obj)) == NULL) {
		printf("JS_GetPrivate failed in X3DMatrix4d.inverse.\n");
		return JS_FALSE;
	}
	cptr = &ptr->v->sfmatrix4d;

	for (i = 0; i < 4; i++)
		matrix[i] = &cptr->c[i * 4];

	//get row scales
	for (i = 0; i < 3; i++)
		retscale[i] = sqrt(vecdot4d(matrix[i], matrix[i]));

	//if (translation) {
	veccopyd(translation.c, matrix[3]);
	//}

	// rotation 
	//if (rotation) {
	double m2[16], ff;
	for (i = 0; i < 3; i++) {
		ff = retscale[i];
		if (ff != 0.0) ff = 1.0 / ff;
		vecscale4d(&m2[i * 4], matrix[i], ff);
	}
	// convert the matrix to a quaternion
	//for(i=0;i<16;i++) matrixd[i] = (double) m2[i];
	matrix_to_quaternion(&quat, m2); // matrixd);

	// convert the quaternion to a VRML rotation 
	quaternion_to_vrmlrot(&quat, &qu[0], &qu[1], &qu[2], &qu[3]);

	// now copy the values over 
	for (i = 0; i < 4; i++)
		rotation.c[i] = (float)qu[i];
	//}

	// scale
	//if (scale) {
	veccopyd(scale.c, retscale);
	//}

	if (argc == 1) {
		if (!JS_ConvertArguments(cx, argc, argv, "o", &transObj)) {
			printf("getTransform, invalid parameters\n");
			return JS_FALSE;
		}
	}
	if (argc == 2) {
		if (!JS_ConvertArguments(cx, argc, argv, "o o", &transObj, &rotObj)) {
			printf("getTransform, invalid parameters\n");
			return JS_FALSE;
		}
	}
	if (argc == 3) {
		if (!JS_ConvertArguments(cx, argc, argv, "o o o",
			&transObj, &rotObj, &scaleObj)) {
			printf("getTransform, invalid parameters\n");
			return JS_FALSE;
		}
	}

	if (transObj) {
		AnyNative* ptr;
		if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, transObj)) == NULL) {
			printf("JS_GetPrivate failed in X3DMatrix4d.getTransform.\n");
			return JS_FALSE;
		}
		shallow_copy_field_precision(FIELDTYPE_SFVec3d, ptr->type, (union anyVrml*)&translation, ptr->v);
	}
	if (rotObj) {
		AnyNative* ptr;
		if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, rotObj)) == NULL) {
			printf("JS_GetPrivate failed in X3DMatrix4d.getTransform.\n");
			return JS_FALSE;
		}
		shallow_copy_field_precision(FIELDTYPE_SFRotation, ptr->type, (union anyVrml*)&rotation, ptr->v);
	}
	if (scaleObj) {
		AnyNative* ptr;
		if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, scaleObj)) == NULL) {
			printf("JS_GetPrivate failed in X3DMatrix4d.getTransform.\n");
			return JS_FALSE;
		}
		shallow_copy_field_precision(FIELDTYPE_SFVec3d, ptr->type, (union anyVrml*)&scale, ptr->v);
	}

	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(NULL)); //JSVAL_VOID);

	return JS_TRUE;
}


/* Sets the X3DMatrix4 to the passed values. Any of the rightmost parameters may be omitted.
   The method has 0 to 5 parameters. For example, specifying 0 parameters results in an
   identity matrix while specifying 1 parameter results in a translation and specifying 2
   parameters results in a translation and a rotation. Any unspecified parameter is set to
   its default as specified for the Transform node. 
	//void setTransform(SFVec3f translation, SFRotation rotation, SFVec3f scale, SFRotation scaleOrientation, SFVec3f center)
	// http://www.web3d.org/documents/specifications/19775-1/V3.3/Part01/components/group.html#Transform
	// P' = T * C * R * SR * S * -SR * -C * P
*/
JSBool
X3DMatrix4setTransform(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	JSObject* transObj = NULL;
	JSObject* rotObj = NULL;
	JSObject* scaleObj = NULL;
	JSObject* scaleOObj = NULL;
	JSObject* centerObj = NULL;
	int i;
	struct SFMatrix4d* cptr;
	struct SFVec3d translation; // = fwpars[0]._web3dval.native;
	struct SFRotation rotation; // = fwpars[1]._web3dval.native;
	struct SFVec3d scale; // = fwpars[2]._web3dval.native;
	struct SFRotation scaleOrientation; // = fwpars[3]._web3dval.native;
	struct SFVec3d center; // = fwpars[4]._web3dval.native;
	//set up some [][] helpers for clarity
	double* matrix[4], * mat[4], m2[16], dval;

	memset(&translation, 0, sizeof(struct SFVec3d));
	memset(&rotation, 0, sizeof(struct SFRotation));
	memset(&scale, 0, sizeof(struct SFVec3d));
	memset(&scaleOrientation, 0, sizeof(struct SFRotation));
	memset(&center, 0, sizeof(struct SFVec3d));
	scale.c[0] = scale.c[1] = scale.c[2] = 1.0;
	rotation.c[0] = 1.0f;

	AnyNative* anyret;
	if ((anyret = (AnyNative*)AnyNativeNew(FIELDTYPE_SFMatrix4d, NULL, NULL)) == NULL) {
		printf("SFMatrix4dNativeNew failed in X3DMatrix4.multLeft.\n");
		return JS_FALSE;
	}

	AnyNative* ptr;
	if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, obj)) == NULL) {
		printf("JS_GetPrivate failed in X3DMatrix4d.inverse.\n");
		return JS_FALSE;
	}
	cptr = &ptr->v->sfmatrix4d;

	int error = FALSE;



	if (argc >= 1) {
		//translation - either a js array [] or SFVec3X
		if (argv[0].isObject()) {
			error = !JS_ValueToObject(cx, argv[0], &transObj);
			if (JS_IsArrayObject(cx, transObj)) {
				jsuint lengthp;
				jsval vp;
				JS_GetArrayLength(cx, transObj, &lengthp);
				int ncopy = lengthp > 3 ? 3 : lengthp;
				for (i = 0; i < ncopy; i++) {
					JS_GetElement(cx, transObj, i, &vp);
					if (JS_ValueToNumber(cx, vp, &dval))
						translation.c[i] = dval;
				}
			}
			else {
				AnyNative* ptr;
				if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, transObj)) == NULL) {
					printf("JS_GetPrivate failed in X3DMatrix3d.setTransform.\n");
					return JS_FALSE;
				}
				shallow_copy_field_precision(ptr->type, FIELDTYPE_SFVec3d, ptr->v, (union anyVrml*)&translation);
			}
		}
	}
	if (argc >= 2) {
		//rotation - SFRotation
		if (argv[1].isObject()) {
			error = !JS_ValueToObject(cx, argv[1], &rotObj);
			if (!JS_IsArrayObject(cx, rotObj)) {
				AnyNative* ptr;
				if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, rotObj)) == NULL) {
					printf("JS_GetPrivate failed in X3DMatrix3d.setTransform.\n");
					return JS_FALSE;
				}
				shallow_copy_field_precision(ptr->type, FIELDTYPE_SFRotation, ptr->v, (union anyVrml*)&rotation);
			}
		}
	}
	if (argc >= 3) {
		//scale - either a scalar, an SFVec3X or js array []
		if (argv[2].isNumber()) {
			JS_ValueToNumber(cx, argv[2], &dval);
			scale.c[0] = scale.c[1] = scale.c[2] = dval;
		}
		else if (argv[2].isObject()) {
			error = !JS_ValueToObject(cx, argv[2], &scaleObj);
			if (JS_IsArrayObject(cx, scaleObj)) {
				jsuint lengthp;
				jsval vp;
				JS_GetArrayLength(cx, scaleObj, &lengthp);
				int ncopy = lengthp > 3 ? 3 : lengthp;
				for (i = 0; i < ncopy; i++) {
					JS_GetElement(cx, scaleObj, i, &vp);
					if (JS_ValueToNumber(cx, vp, &dval))
						scale.c[i] = dval;
				}
			}
			else {
				AnyNative* ptr;
				if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, scaleObj)) == NULL) {
					printf("JS_GetPrivate failed in X3DMatrix3d.setTransform.\n");
					return JS_FALSE;
				}
				shallow_copy_field_precision(ptr->type, FIELDTYPE_SFVec3d, ptr->v, (union anyVrml*)&scale);
			}
		}
	}
	if (argc >= 4) {
		//scaleOrientation SFRotation
		error = !JS_ConvertArguments(cx, argc, argv, "o o o o", &transObj, &rotObj, &scaleObj, &scaleOObj);
		if (argv[3].isObject()) {
			error = !JS_ValueToObject(cx, argv[3], &scaleOObj);
			if (!JS_IsArrayObject(cx, scaleOObj)) {
				AnyNative* ptr;
				if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, scaleOObj)) == NULL) {
					printf("JS_GetPrivate failed in X3DMatrix3d.setTransform.\n");
					return JS_FALSE;
				}
				shallow_copy_field_precision(ptr->type, FIELDTYPE_SFRotation, ptr->v, (union anyVrml*)&scaleOrientation);
			}
		}
	}
	if (argc >= 5) {
		if (argv[4].isObject()) {
			error = !JS_ValueToObject(cx, argv[4], &centerObj);
			if (JS_IsArrayObject(cx, centerObj)) {
				jsuint lengthp;
				jsval vp;
				JS_GetArrayLength(cx, centerObj, &lengthp);
				int ncopy = lengthp > 3 ? 3 : lengthp;
				for (i = 0; i < ncopy; i++) {
					JS_GetElement(cx, centerObj, i, &vp);
					if (JS_ValueToNumber(cx, vp, &dval))
						translation.c[i] = dval;
				}
			}
			else {
				AnyNative* ptr;
				if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, centerObj)) == NULL) {
					printf("JS_GetPrivate failed in X3DMatrix3d.setTransform.\n");
					return JS_FALSE;
				}
				shallow_copy_field_precision(ptr->type, FIELDTYPE_SFVec3d, ptr->v, (union anyVrml*)&center);
			}
		}
	}

	if (error) {
		ConsoleMessage("setTransform: error in parameters");
		return JS_FALSE;
	}


	/* apply Transform, if requested */
	//if (transObj) {
	//	AnyNative* ptr;
	//	if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, transObj)) == NULL) {
	//		printf("JS_GetPrivate failed in X3DMatrix4d.setTransform.\n");
	//		return JS_FALSE;
	//	}
	//	shallow_copy_field_precision(ptr->type, FIELDTYPE_SFVec3d, ptr->v, (union anyVrml*)&translation);
	//}
	//if (rotObj) {
	//	AnyNative* ptr;
	//	if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, rotObj)) == NULL) {
	//		printf("JS_GetPrivate failed in X3DMatrix4d.setTransform.\n");
	//		return JS_FALSE;
	//	}
	//	shallow_copy_field_precision(ptr->type, FIELDTYPE_SFRotation, ptr->v, (union anyVrml*)&rotation);
	//}
	//if (scaleObj) {
	//	AnyNative* ptr;
	//	if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, scaleObj)) == NULL) {
	//		printf("JS_GetPrivate failed in X3DMatrix4d.setTransform.\n");
	//		return JS_FALSE;
	//	}
	//	shallow_copy_field_precision(ptr->type, FIELDTYPE_SFVec3d, ptr->v, (union anyVrml*)&scale);
	//}
	//if (scaleOObj) {
	//	AnyNative* ptr;
	//	if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, scaleOObj)) == NULL) {
	//		printf("JS_GetPrivate failed in X3DMatrix4d.setTransform.\n");
	//		return JS_FALSE;
	//	}
	//	shallow_copy_field_precision(ptr->type, FIELDTYPE_SFRotation, ptr->v, (union anyVrml*)&scaleOrientation);
	//}
	//if (centerObj) {
	//	AnyNative* ptr;
	//	if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, centerObj)) == NULL) {
	//		printf("JS_GetPrivate failed in X3DMatrix4d.setTransform.\n");
	//		return JS_FALSE;
	//	}
	//	shallow_copy_field_precision(ptr->type, FIELDTYPE_SFVec3d, ptr->v, (union anyVrml*)&center);
	//}

	for (i = 0; i < 4; i++) {
		matrix[i] = &cptr->c[i * 4]; //our current matrix3
		mat[i] = &m2[i * 4]; //scratch matrix
	}
	//initialize to Identity
	matidentity4d(matrix[0]);

	//T
	//if(translation){
	matidentity4d(mat[0]);
	veccopyd(mat[3], translation.c);
	matmultiplyFULL(matrix[0], mat[0], matrix[0]);
	//}
	//C
	//if(center){
	matidentity4d(mat[0]);
	veccopyd(mat[3], center.c);
	matmultiplyFULL(matrix[0], mat[0], matrix[0]);
	//}

	//R
	//if(rotation){
	matidentity4d(mat[0]);
	for (i = 0; i < 3; i++)
		axisangle_rotate3d(mat[i], mat[i], rotation.c);
	matmultiplyFULL(matrix[0], mat[0], matrix[0]);
	//}

	//SR
	//if(scaleOrientation){
	matidentity4d(mat[0]);
	for (i = 0; i < 3; i++)
		axisangle_rotate3d(mat[i], mat[i], scaleOrientation.c);
	matmultiplyFULL(matrix[0], mat[0], matrix[0]);
	//}

	//S
	//if(scale){
	matidentity4d(mat[0]);
	for (i = 0; i < 4; i++)
		vecmult3d(mat[i], mat[i], scale.c);
	matmultiplyFULL(matrix[0], mat[0], matrix[0]);
	//}

	// 
	//-SR
	//if(scaleOrientation){
	scaleOrientation.c[3] = -scaleOrientation.c[3];
	matidentity4d(mat[0]);
	for (i = 0; i < 3; i++)
		axisangle_rotate3d(mat[i], mat[i], scaleOrientation.c);
	matmultiplyFULL(matrix[0], mat[0], matrix[0]);
	scaleOrientation.c[3] = -scaleOrientation.c[3];
	//}

	//-C
	//if(center){
	matidentity4d(mat[0]);
	veccopyd(mat[3], center.c);
	vecscaled(mat[3], mat[3], -1.0f);
	matmultiplyFULL(matrix[0], mat[0], matrix[0]);
	//}

	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(NULL)); //JSVAL_VOID);

	return JS_TRUE;
}


JSBool
X3DMatrix4inverse(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	struct SFMatrix4d* cptr;
	struct SFMatrix4d* ret;
	JSObject* retObj = NULL;

	AnyNative* anyret;
	if ((anyret = (AnyNative*)AnyNativeNew(FIELDTYPE_SFMatrix4d, NULL, NULL)) == NULL) {
		printf("SFMatrix4dNativeNew failed in X3DMatrix4.multLeft.\n");
		return JS_FALSE;
	}

	AnyNative* ptr;
	if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, obj)) == NULL) {
		printf("JS_GetPrivate failed in X3DMatrix4d.inverse.\n");
		return JS_FALSE;
	}
	cptr = &ptr->v->sfmatrix4d;
	ret = &anyret->v->sfmatrix4d;
	matidentity4d(ret->c);

	matinverseFULL(ret->c, cptr->c);

	retObj = JS_NewObject(cx, &X3DMatrix4Class, NULL, NULL);
	if (!JS_SetPrivateFw(cx, retObj, anyret)) {
		printf("JS_SetPrivate failed in X3DMatrix4.inverse.\n");
		return JS_FALSE;
	}
	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(retObj));
	return JS_TRUE;
}


JSBool
X3DMatrix4transpose(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	struct SFMatrix4d* cptr;
	struct SFMatrix4d* ret;
	JSObject* retObj = NULL;

	AnyNative* anyret;
	if ((anyret = (AnyNative*)AnyNativeNew(FIELDTYPE_SFMatrix4d, NULL, NULL)) == NULL) {
		printf("SFMatrix4dNativeNew failed in X3DMatrix4.multLeft.\n");
		return JS_FALSE;
	}

	AnyNative* ptr;
	if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, obj)) == NULL) {
		printf("JS_GetPrivate failed in X3DMatrix4d.transpose.\n");
		return JS_FALSE;
	}
	cptr = &ptr->v->sfmatrix4d;
	ret = &anyret->v->sfmatrix4d;
	mattranspose(ret->c, cptr->c);

	retObj = JS_NewObject(cx, &X3DMatrix4Class, NULL, NULL);
	if (!JS_SetPrivateFw(cx, retObj, anyret)) {
		printf("JS_SetPrivate failed in X3DMatrix4.inverse.\n");
		return JS_FALSE;
	}
	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(retObj));
	return JS_TRUE;
}



JSBool
X3DMatrix4multLeft(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	struct SFMatrix4d rhs;
	struct SFMatrix4d* cptr;
	struct SFMatrix4d* ret;
	JSObject* rhsObj = NULL;
	JSObject* retObj = NULL;

	AnyNative* anyret;
	if ((anyret = (AnyNative*)AnyNativeNew(FIELDTYPE_SFMatrix4d, NULL, NULL)) == NULL) {
		printf("SFMatrix4dNativeNew failed in X3DMatrix4.multLeft.\n");
		return JS_FALSE;
	}
	
	AnyNative* ptr;
	if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, obj)) == NULL) {
		printf("JS_GetPrivate failed in X3DMatrix4d.multLeft.\n");
		return JS_FALSE;
	}
	cptr = &ptr->v->sfmatrix4d;
	ret =  &anyret->v->sfmatrix4d;
	matidentity4d(ret->c);
	matidentity4d(rhs.c);

	if (argc == 1) {
		if (!JS_ConvertArguments(cx, argc, argv, "o", &rhsObj)) {
			printf("JS_ConvertArgs failed in X3DMatrix4d.multLeft.\n");
			return JS_FALSE;
		}
		AnyNative* rhsptr;
		if ((rhsptr = (AnyNative*)JS_GetPrivateFw(cx, rhsObj)) == NULL) {
			printf("JS_GetPrivate failed in X3DMatrix4d.multLeft.\n");
			return JS_FALSE;
		}
		shallow_copy_field_precision(rhsptr->type, FIELDTYPE_SFMatrix4d, rhsptr->v, (union anyVrml*)&rhs);
	}
	matmultiplyFULL(ret->c, rhs.c, cptr->c);

	retObj = JS_NewObject(cx, &X3DMatrix4Class, NULL, NULL); 
	if (!JS_SetPrivateFw(cx, retObj, anyret)) {
		printf("JS_SetPrivate failed in SFMatrix3dConstr.\n");
		return JS_FALSE;
	}
	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(retObj));
	return JS_TRUE;
}

JSBool
X3DMatrix4multRight(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	struct SFMatrix4d rhs;
	struct SFMatrix4d* cptr;
	struct SFMatrix4d* ret;
	JSObject* rhsObj = NULL;
	JSObject* retObj = NULL;

	AnyNative* anyret;
	if ((anyret = (AnyNative*)AnyNativeNew(FIELDTYPE_SFMatrix4d, NULL, NULL)) == NULL) {
		printf("SFMatrix4dNativeNew failed in X3DMatrix4.multLeft.\n");
		return JS_FALSE;
	}

	AnyNative* ptr;
	if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, obj)) == NULL) {
		printf("JS_GetPrivate failed in X3DMatrix4d.multLeft.\n");
		return JS_FALSE;
	}
	cptr = &ptr->v->sfmatrix4d;
	ret = &anyret->v->sfmatrix4d;
	matidentity4d(ret->c);
	matidentity4d(rhs.c);

	if (argc == 1) {
		if (!JS_ConvertArguments(cx, argc, argv, "o", &rhsObj)) {
			printf("JS_ConvertArgs failed in X3DMatrix4d.multLeft.\n");
			return JS_FALSE;
		}
		AnyNative* rhsptr;
		if ((rhsptr = (AnyNative*)JS_GetPrivateFw(cx, rhsObj)) == NULL) {
			printf("JS_GetPrivate failed in X3DMatrix4d.multLeft.\n");
			return JS_FALSE;
		}
		shallow_copy_field_precision(rhsptr->type, FIELDTYPE_SFMatrix4d, rhsptr->v, (union anyVrml*)&rhs);
	}
	matmultiplyFULL(ret->c, cptr->c, rhs.c);

	retObj = JS_NewObject(cx, &X3DMatrix4Class, NULL, NULL);
	if (!JS_SetPrivateFw(cx, retObj, anyret)) {
		printf("JS_SetPrivate failed in X3DMatrix4d.multLeft.\n");
		return JS_FALSE;
	}
	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(retObj));
	return JS_TRUE;
}


JSBool
X3DMatrix4multVecMatrix(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	struct SFVec3d rhs;
	struct SFMatrix4d* cptr;
	struct SFVec3d* ret;
	JSObject* rhsObj = NULL;
	JSObject* retObj = NULL;

	AnyNative* anyret;
	if ((anyret = (AnyNative*)AnyNativeNew(FIELDTYPE_SFVec3d, NULL, NULL)) == NULL) {
		printf("SFVec3dNativeNew failed in X3DMatrix4.multVecMatrix.\n");
		return JS_FALSE;
	}

	AnyNative* ptr;
	if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, obj)) == NULL) {
		printf("JS_GetPrivate failed in X3DMatrix4d.multVecMatrix.\n");
		return JS_FALSE;
	}
	cptr = &ptr->v->sfmatrix4d;
	ret = &anyret->v->sfvec3d;
	vecsetd(ret->c,0.0,0.0,0.0);
	vecsetd(rhs.c, 0.0, 0.0, 0.0);

	if (argc == 1) {
		if (!JS_ConvertArguments(cx, argc, argv, "o", &rhsObj)) {
			printf("JS_ConvertArgs failed in X3DMatrix4d.multVecMatrix.\n");
			return JS_FALSE;
		}
		AnyNative* rhsptr;
		if ((rhsptr = (AnyNative*)JS_GetPrivateFw(cx, rhsObj)) == NULL) {
			printf("JS_GetPrivate failed in X3DMatrix4d.multVecMatrix.\n");
			return JS_FALSE;
		}
		shallow_copy_field_precision(rhsptr->type, FIELDTYPE_SFVec3d, rhsptr->v, (union anyVrml*)&rhs);
	}
	double a4[4], r4[4];
	veccopyd(a4, rhs.c);
	a4[3] = 1.0;
	vecmultmat4d(r4, a4, cptr->c);
	if (r4[3] != 0.0) {
		double wi = 1.0 / r4[3];
		vecscaled(ret->c, r4, wi);
	}
	else {
		veccopyd(ret->c, r4);
	}

	retObj = JS_NewObject(cx, &SFVec3dClass, NULL, NULL);
	if (!JS_SetPrivateFw(cx, retObj, anyret)) {
		printf("JS_SetPrivate failed in X3DMatrix4d.multVecMatrix.\n");
		return JS_FALSE;
	}
	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(retObj));
	return JS_TRUE;
}


JSBool
X3DMatrix4multMatrixVec(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	struct SFVec3d rhs;
	struct SFMatrix4d* cptr;
	struct SFVec3d* ret;
	JSObject* rhsObj = NULL;
	JSObject* retObj = NULL;

	AnyNative* anyret;
	if ((anyret = (AnyNative*)AnyNativeNew(FIELDTYPE_SFVec3d, NULL, NULL)) == NULL) {
		printf("SFVec3dNativeNew failed in X3DMatrix4.multVecMatrix.\n");
		return JS_FALSE;
	}

	AnyNative* ptr;
	if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, obj)) == NULL) {
		printf("JS_GetPrivate failed in X3DMatrix4d.multVecMatrix.\n");
		return JS_FALSE;
	}
	cptr = &ptr->v->sfmatrix4d;
	ret = &anyret->v->sfvec3d;
	vecsetd(ret->c, 0.0, 0.0, 0.0);
	vecsetd(rhs.c, 0.0, 0.0, 0.0);

	if (argc == 1) {
		if (!JS_ConvertArguments(cx, argc, argv, "o", &rhsObj)) {
			printf("JS_ConvertArgs failed in X3DMatrix4d.multVecMatrix.\n");
			return JS_FALSE;
		}
		AnyNative* rhsptr;
		if ((rhsptr = (AnyNative*)JS_GetPrivateFw(cx, rhsObj)) == NULL) {
			printf("JS_GetPrivate failed in X3DMatrix4d.multVecMatrix.\n");
			return JS_FALSE;
		}
		shallow_copy_field_precision(rhsptr->type, FIELDTYPE_SFVec3d, rhsptr->v, (union anyVrml*)&rhs);
	}
	double a4[4], r4[4];
	veccopyd(a4, rhs.c);
	a4[3] = 1.0;
	matmultvec4d(r4, cptr->c, a4);
	if (r4[3] != 0.0) {
		double wi = 1.0 / r4[3];
		vecscaled(ret->c, r4, wi);
	}
	else {
		veccopyd(ret->c, r4);
	}

	retObj = JS_NewObject(cx, &SFVec3dClass, NULL, NULL);
	if (!JS_SetPrivateFw(cx, retObj, anyret)) {
		printf("JS_SetPrivate failed in X3DMatrix4d.multVecMatrix.\n");
		return JS_FALSE;
	}
	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(retObj));
	return JS_TRUE;
}


JSBool
X3DMatrix4Assign(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;
	if (!_standardMFAssign(cx, obj, argc, argv, &rval, &X3DMatrix4Class, FIELDTYPE_FreeWRLPTR/*does not matter*/)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;
}


JSBool
X3DMatrix4Constr(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_NewObject(cx, &X3DMatrix4Class, NULL, NULL);
	jsval* argv = JS_ARGV(cx, vp);
	jsdouble pars[16];
	double* cc;

	ADD_ROOT(cx, obj)
	AnyNative* any;
	if ((any = (AnyNative*)AnyNativeNew(FIELDTYPE_SFMatrix4d, NULL, NULL)) == NULL) {
		printf("SFMatrix4dNativeNew failed in X3DMatrix4Constr.\n");
		return JS_FALSE;
	}

	if (!JS_SetPrivateFw(cx, obj, any)) {
		printf("JS_SetPrivate failed in SFMatrix4dConstr.\n");
		return JS_FALSE;
	}
	cc = any->v->sfmatrix4d.c;

	matidentity4d(cc);

	int ncopy = 0;
	if (argc == 1) {
		JSObject* paramObj;
		int isArray;

		if (!JS_ValueToObject(cx, argv[0], &paramObj)) {
			printf("JS_ValueToObject failed in SFMatrix4dConstr.\n");
			return JS_FALSE;
		}

		if (JS_IsArrayObject(cx, paramObj)) {
			jsuint lengthp;
			jsval vp;
			double _d;
			//printf("its an array\n");
			isArray = TRUE;
			JS_GetArrayLength(cx, paramObj, &lengthp);
			ncopy = lengthp > 16 ? 16 : lengthp;
			for (int i = 0; i < ncopy; i++) {
				JS_GetElement(cx, paramObj, i, &vp);
				if (JS_ValueToNumber(cx, vp, &_d))
					cc[i] = _d;
			}
		}
		else {

			AnyNative* pptr;
			if ((pptr = (AnyNative*)JS_GetPrivateFw(cx, paramObj)) == NULL) {
				printf("JS_GetPrivate failed in X3DMatrix4Constr.\n");
				return JS_FALSE;
			}
			shallow_copy_field_precision(pptr->type, FIELDTYPE_SFMatrix4d, pptr->v, (union anyVrml*)cc);
		}
	}
	else if (argc == 16) {
		if (!JS_ConvertArguments(cx, argc, argv, "d d d d d d d d d d d d d d d d",
			&(pars[0]), &(pars[1]), &(pars[2]), &(pars[3]),
			&(pars[4]), &(pars[5]), &(pars[6]), &(pars[7]),
			&(pars[8]), &(pars[9]), &(pars[10]), &(pars[11]),
			&(pars[12]), &(pars[13]), &(pars[14]), &(pars[15])
		))
		{
			printf("JS_ConvertArguments failed in X3DMatrix4Constr.\n");
			return JS_FALSE;
		}
		for (int i = 0; i < 16; i++)
			cc[i] = (double)pars[i];
	}
	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(obj));
	return JS_TRUE;
}

JSBool
X3DMatrix4AddProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();
	return doMFAddProperty(cx, obj, id, vp, "X3DMatrix4AddProperty");
}

JSBool
X3DMatrix4GetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid iid = *hiid.address();
	jsval* vp = hvp.address();
	int index;

	jsval id;
	if (!JS_IdToValue(cx, iid, &id)) {
		printf("JS_IdToValue failed in X3DMatrix4.GetProperty.\n");
		return JS_FALSE;
	}

	if (JSVAL_IS_INT(id)) {
		index = JSVAL_TO_INT(id);
		if (index > -1 && index < 4) {
			struct SFMatrix4d* cptr;

			AnyNative* ptr;
			if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, obj)) == NULL) {
				printf("JS_GetPrivate failed in X3DMatrix4d.multLeft.\n");
				return JS_FALSE;
			}
			cptr = &ptr->v->sfmatrix4d;
			double* row = &cptr->c[index * 4];

			AnyNative* anyret;
			if ((anyret = (AnyNative*)AnyNativeNew(FIELDTYPE_SFVec4d, NULL, NULL)) == NULL) {
				printf("SFVec4dNativeNew failed in X3DMatrix4.GetProperty.\n");
				return JS_FALSE;
			}
			anyret->gc = 0;
			anyret->type = FIELDTYPE_SFVec4d;
			anyret->v = (union anyVrml*)row;
			JSObject *retObj = JS_NewObject(cx, &SFVec4dClass, NULL, NULL);
			if (!JS_SetPrivateFw(cx, retObj, anyret)) {
				printf("JS_SetPrivate failed in SFMatrix3dConstr.\n");
				return JS_FALSE;
			}
			JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(retObj));
			return JS_TRUE;

		}
	}
	else if (id.isObject()) {
	}

	return JS_TRUE;
}

JSBool
X3DMatrix4SetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JSBool strict, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid iid = *hiid.address();
	jsval* vp = hvp.address();

	int index;

	jsval id;
	if (!JS_IdToValue(cx, iid, &id)) {
		printf("JS_IdToValue failed in X3DMatrix4.GetProperty.\n");
		return JS_FALSE;
	}

	if (JSVAL_IS_INT(id)) {
		index = JSVAL_TO_INT(id);
		if (index > -1 && index < 4) {
			struct SFMatrix4d* cptr;
			double rhs;
			if (!JS_ValueToNumber(cx, *vp, &rhs)) {
				printf("problems converting Javascript val to number in X3DMatrix.SetProperty\n");
				return JS_FALSE;
			}

			AnyNative* ptr;
			if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, obj)) == NULL) {
				printf("JS_GetPrivate failed in X3DMatrix4d.multLeft.\n");
				return JS_FALSE;
			}
			cptr = &ptr->v->sfmatrix4d;
			double* row = &cptr->c[index * 4];
			row[index] = 100.0; //****
			return JS_TRUE;

		}
	}
	else if (id.isObject()) {
	}

	return JS_TRUE;
}

// X3DMatrix3

JSBool
X3DMatrix3ToString(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);

	JSString* _str;
	double* cc;
	char buff[STRING];

	UNUSED(argc);
	UNUSED(argv);
	if (SM_method() == 2) {
		AnyNative* ptr;
		if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, obj)) == NULL) {
			printf("JS_GetPrivate failed in SFMatrix3dToString.\n");
			return JS_FALSE;
		}
		cc = ptr->v->sfmatrix3d.c;
	}
	memset(buff, 0, STRING);
	sprintf(buff, "%.9g %.9g %.9g, %.9g %.9g %.9g, %.9g %.9g %.9g",
		cc[0], cc[1], cc[2], 
		cc[3], cc[4], cc[5], 
		cc[6], cc[7], cc[8]
	);
	_str = JS_NewStringCopyZ(cx, buff);

	JS_SET_RVAL(cx, vp, STRING_TO_JSVAL(_str));
	return JS_TRUE;
}

JSBool
X3DMatrix3getTransform(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	int i;
	JSObject* transObj = NULL;
	JSObject* rotObj = NULL;
	JSObject* scaleObj = NULL;

	struct SFMatrix3d* cptr;
	struct SFVec2d translation;
	struct SFVec3d rotation;
	struct SFVec2d scale;
	double* matrix[3], retscale[2];
	double matrixd[9], angle;


	AnyNative* ptr;
	if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, obj)) == NULL) {
		printf("JS_GetPrivate failed in X3DMatrix3d.inverse.\n");
		return JS_FALSE;
	}
	cptr = &ptr->v->sfmatrix3d;

	for (i = 0; i < 3; i++)
		matrix[i] = &cptr->c[i * 3];

	//get row scales
	for (i = 0; i < 2; i++)
		retscale[i] = sqrt(vecdotd(matrix[i], matrix[i]));
	veccopy2d(scale.c, retscale);
	//if (translation) {
	veccopy2d(translation.c, matrix[2]);

	//}

	/* rotation */
	if (1) {
		/* apply length to each row to normalize upperleft 3x3 to rotations and shears*/
		double m2[9], ff;
		for (i = 0; i < 2; i++) {
			ff = retscale[i];
			if (ff != 0.0f) ff = 1 / ff;
			vecscaled(&m2[i * 3], matrix[i], ff);
		}
		angle = atan2(m2[1], m2[2]); //right indexes? should be 0 and 1?
		/* now copy the values over */
		//if(rotation) 
		memset(&rotation, 0, sizeof(struct SFVec3d));
		rotation.c[0] = cos(angle);
		rotation.c[1] = sin(angle);
		rotation.c[2] = angle;
	}

	if (argc == 1) {
		if (!JS_ConvertArguments(cx, argc, argv, "o", &transObj)) {
			printf("getTransform, invalid parameters\n");
			return JS_FALSE;
		}
	}
	if (argc == 2) {
		if (!JS_ConvertArguments(cx, argc, argv, "o o", &transObj, &rotObj)) {
			printf("getTransform, invalid parameters\n");
			return JS_FALSE;
		}
	}
	if (argc == 3) {
		if (!JS_ConvertArguments(cx, argc, argv, "o o o",
			&transObj, &rotObj, &scaleObj)) {
			printf("getTransform, invalid parameters\n");
			return JS_FALSE;
		}
	}

	if (transObj) {
		AnyNative* ptr;
		if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, transObj)) == NULL) {
			printf("JS_GetPrivate failed in X3DMatrix3d.getTransform.\n");
			return JS_FALSE;
		}
		shallow_copy_field_precision(FIELDTYPE_SFVec2d, ptr->type, (union anyVrml*)&translation, ptr->v);
	}
	if (rotObj) {
		AnyNative* ptr;
		if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, rotObj)) == NULL) {
			printf("JS_GetPrivate failed in X3DMatrix3d.getTransform.\n");
			return JS_FALSE;
		}
		shallow_copy_field_precision(FIELDTYPE_SFVec3d, ptr->type, (union anyVrml*)&rotation, ptr->v);
	}
	if (scaleObj) {
		AnyNative* ptr;
		if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, scaleObj)) == NULL) {
			printf("JS_GetPrivate failed in X3DMatrix3d.getTransform.\n");
			return JS_FALSE;
		}
		shallow_copy_field_precision(FIELDTYPE_SFVec2d, ptr->type, (union anyVrml*)&scale, ptr->v);
	}

	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(NULL)); //JSVAL_VOID);

	return JS_TRUE;
}


/* Sets the X3DMatrix3 to the passed values. Any of the rightmost parameters may be omitted.
   The method has 0 to 5 parameters. For example, specifying 0 parameters results in an
   identity matrix while specifying 1 parameter results in a translation and specifying 2
   parameters results in a translation and a rotation. Any unspecified parameter is set to
   its default as specified for the Transform node.
	//void setTransform(SFVec3f translation, SFVec3f rotation, SFVec3f scale, SFVec3f scaleOrientation, SFVec3f center)
	// http://www.web3d.org/documents/specifications/19775-1/V3.3/Part01/components/group.html#Transform
	// P' = T * C * R * SR * S * -SR * -C * P
*/
JSBool
X3DMatrix3setTransform(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	JSObject* transObj = NULL;
	JSObject* rotObj = NULL;
	JSObject* scaleObj = NULL;
	JSObject* scaleOObj = NULL;
	JSObject* centerObj = NULL;
	int i;
	struct SFMatrix3d* cptr;
	struct SFVec2d translation; // = fwpars[0]._web3dval.native;
	struct SFVec3d rotation; // = fwpars[1]._web3dval.native;
	struct SFVec2d scale; // = fwpars[2]._web3dval.native;
	struct SFVec3d scaleOrientation; // = fwpars[3]._web3dval.native;
	struct SFVec2d center; // = fwpars[4]._web3dval.native;
	//set up some [][] helpers for clarity
	double* matrix[3], * mat[3], m2[9], angle, scaleangle, dval;

	memset(&translation, 0, sizeof(struct SFVec2d));
	memset(&rotation, 0, sizeof(struct SFVec3d));
	memset(&scale, 0, sizeof(struct SFVec2d));
	memset(&scaleOrientation, 0, sizeof(struct SFVec3d));
	memset(&center, 0, sizeof(struct SFVec2d));
	scale.c[0] = scale.c[1] = 1.0;
	angle = scaleangle = 0.0;

	AnyNative* anyret;
	if ((anyret = (AnyNative*)AnyNativeNew(FIELDTYPE_SFMatrix3d, NULL, NULL)) == NULL) {
		printf("SFMatrix3dNativeNew failed in X3DMatrix3.multLeft.\n");
		return JS_FALSE;
	}

	AnyNative* ptr;
	if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, obj)) == NULL) {
		printf("JS_GetPrivate failed in X3DMatrix3d.inverse.\n");
		return JS_FALSE;
	}
	cptr = &ptr->v->sfmatrix3d;

	int error = FALSE;

	if (argc >= 1) {
		//Translation, either SFVecXX or js [] array
		error = !JS_ValueToObject(cx, argv[0], &transObj);
		if (JS_IsArrayObject(cx, transObj)) {
			jsuint lengthp;
			jsval vp;
			JS_GetArrayLength(cx, transObj, &lengthp);
			int ncopy = lengthp > 2 ? 2 : lengthp;
			for (i = 0; i < 2; i++) {
				JS_GetElement(cx, transObj, i, &vp);
				if (JS_ValueToNumber(cx, vp, &dval))
					translation.c[i] = dval;
			}
		}
		else {
			AnyNative* ptr;
			if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, transObj)) == NULL) {
				printf("JS_GetPrivate failed in X3DMatrix3d.setTransform.\n");
				return JS_FALSE;
			}
			shallow_copy_field_precision(ptr->type, FIELDTYPE_SFVec2d, ptr->v, (union anyVrml*)&translation);
		}
	}
	if (argc >= 2) {
		// rotation either scalar or SFVec3X
		if (argv[1].isNumber()) {
			double val;
			JS_ValueToNumber(cx, argv[1], &val);
			angle = val;
		}
		else {
			error = !JS_ValueToObject(cx, argv[1], &rotObj);
			AnyNative* ptr;
			if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, rotObj)) == NULL) {
				printf("JS_GetPrivate failed in X3DMatrix3d.setTransform.\n");
				return JS_FALSE;
			}
			shallow_copy_field_precision(ptr->type, FIELDTYPE_SFVec3d, ptr->v, (union anyVrml*)&rotation);
			angle = rotation.c[2];
		}
	}
	if (argc >= 3) {
		//scale - either a scalar or js array [] or SFVec2X
		if (argv[2].isNumber()) {
			double val;
			JS_ValueToNumber(cx, argv[2], &val);
			scale.c[0] = scale.c[1] = val;
		}
		else if (argv[2].isObject()) {
			error = !JS_ValueToObject(cx, argv[2], &scaleObj);
			if (JS_IsArrayObject(cx, scaleObj)) {
				jsuint lengthp;
				jsval vp;
				JS_GetArrayLength(cx, scaleObj, &lengthp);
				int ncopy = lengthp > 2 ? 2 : lengthp;
				for (i = 0; i < 2; i++) {
					JS_GetElement(cx, scaleObj, i, &vp);
					if (JS_ValueToNumber(cx, vp, &dval))
						scale.c[i] = dval;
				}
			}
			else {
				AnyNative* ptr;
				if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, scaleObj)) == NULL) {
					printf("JS_GetPrivate failed in X3DMatrix3d.setTransform.\n");
					return JS_FALSE;
				}
				shallow_copy_field_precision(ptr->type, FIELDTYPE_SFVec2d, ptr->v, (union anyVrml*)&scale);
			}
		}
	}
	if (argc >= 4) {
		//scaleOrientation either a scalar or SFVec3X
		if (argv[3].isNumber()) {
			double val;
			JS_ValueToNumber(cx, argv[3], &val);
			scaleangle = val;
		}
		else {
			error = !JS_ValueToObject(cx, argv[3], &scaleOObj);
			AnyNative* ptr;
			if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, scaleOObj)) == NULL) {
				printf("JS_GetPrivate failed in X3DMatrix3d.setTransform.\n");
				return JS_FALSE;
			}
			shallow_copy_field_precision(ptr->type, FIELDTYPE_SFVec3d, ptr->v, (union anyVrml*)&rotation);
			scaleangle = rotation.c[2];
		}
	}
	if (argc >= 5) {
		//center either an SFVec2X or js array[]
		if (argv[4].isObject()) {
			error = !JS_ValueToObject(cx, argv[4], &centerObj);
			if (JS_IsArrayObject(cx, centerObj)) {
				jsuint lengthp;
				jsval vp;
				JS_GetArrayLength(cx, centerObj, &lengthp);
				int ncopy = lengthp > 2 ? 2 : lengthp;
				for (i = 0; i < 2; i++) {
					JS_GetElement(cx, centerObj, i, &vp);
					if (JS_ValueToNumber(cx, vp, &dval))
						center.c[i] = dval;
				}
			}
			else {
				AnyNative* ptr;
				if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, centerObj)) == NULL) {
					printf("JS_GetPrivate failed in X3DMatrix3d.setTransform.\n");
					return JS_FALSE;
				}
				shallow_copy_field_precision(ptr->type, FIELDTYPE_SFVec2d, ptr->v, (union anyVrml*)&center);
			}
		}
	}

	if (error) {
		ConsoleMessage("setTransform: error in parameters");
		return JS_FALSE;
	}

	for (i = 0; i < 3; i++) {
		matrix[i] = &cptr->c[i * 3];
		mat[i] = &m2[i * 3];
	}
	//initialize to Identity
	matidentity3d(matrix[0]);

	//T
	//if(translation){
	matidentity3d(mat[0]);
	veccopy2d(mat[2], translation.c);
	matmultiply3d(matrix[0], mat[0], matrix[0]);
	//}
	//C
	//if(center){
	matidentity3d(mat[0]);
	veccopy2d(mat[2], center.c);
	matmultiply3d(matrix[0], mat[0], matrix[0]);
	//}
	//R
	if (angle != 0.0f) {
		matidentity3d(mat[0]);
		mat[0][0] = mat[1][1] = cos(angle);
		mat[0][1] = mat[1][0] = sin(angle);
		mat[1][0] = -mat[1][0];
		matmultiply3d(matrix[0], mat[0], matrix[0]);
	}
	//SR
	if (scaleangle != 0.0f) {
		matidentity3d(mat[0]);
		mat[0][0] = mat[1][1] = cos(scaleangle);
		mat[0][1] = mat[1][0] = sin(scaleangle);
		mat[1][0] = -mat[1][0];
		matmultiply3d(matrix[0], mat[0], matrix[0]);
	}
	//S
	//if(scale){
	matidentity3d(mat[0]);
	for (i = 0; i < 3; i++)
		vecmult2d(mat[i], mat[i], scale.c);
	matmultiply3d(matrix[0], mat[0], matrix[0]);
	//}

	//-SR
	if (scaleangle != 0.0) {
		matidentity3d(mat[0]);
		mat[0][0] = mat[1][1] = cos(-scaleangle);
		mat[0][1] = mat[1][0] = sin(-scaleangle);
		mat[1][0] = -mat[1][0];
		matmultiply3d(matrix[0], mat[0], matrix[0]);
	}

	//-C
	//if(center){
	matidentity3d(mat[0]);
	veccopy2d(mat[2], center.c);
	vecscale2d(mat[2], mat[2], -1.0);
	matmultiply3d(matrix[0], mat[0], matrix[0]);
	//}

	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(NULL)); //JSVAL_VOID);

	return JS_TRUE;
}


JSBool
X3DMatrix3inverse(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	struct SFMatrix3d* cptr;
	struct SFMatrix3d* ret;
	JSObject* retObj = NULL;

	AnyNative* anyret;
	if ((anyret = (AnyNative*)AnyNativeNew(FIELDTYPE_SFMatrix3d, NULL, NULL)) == NULL) {
		printf("SFMatrix3dNativeNew failed in X3DMatrix3.multLeft.\n");
		return JS_FALSE;
	}

	AnyNative* ptr;
	if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, obj)) == NULL) {
		printf("JS_GetPrivate failed in X3DMatrix3d.inverse.\n");
		return JS_FALSE;
	}
	cptr = &ptr->v->sfmatrix3d;
	ret = &anyret->v->sfmatrix3d;

	matinverse3d(ret->c, cptr->c);

	retObj = JS_NewObject(cx, &X3DMatrix3Class, NULL, NULL);
	if (!JS_SetPrivateFw(cx, retObj, anyret)) {
		printf("JS_SetPrivate failed in X3DMatrix3.inverse.\n");
		return JS_FALSE;
	}
	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(retObj));
	return JS_TRUE;
}


JSBool
X3DMatrix3transpose(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	struct SFMatrix3d* cptr;
	struct SFMatrix3d* ret;
	JSObject* retObj = NULL;

	AnyNative* anyret;
	if ((anyret = (AnyNative*)AnyNativeNew(FIELDTYPE_SFMatrix3d, NULL, NULL)) == NULL) {
		printf("SFMatrix3dNativeNew failed in X3DMatrix3.multLeft.\n");
		return JS_FALSE;
	}

	AnyNative* ptr;
	if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, obj)) == NULL) {
		printf("JS_GetPrivate failed in X3DMatrix3d.transpose.\n");
		return JS_FALSE;
	}
	cptr = &ptr->v->sfmatrix3d;
	ret = &anyret->v->sfmatrix3d;
	mattranspose3d(ret->c, cptr->c);

	retObj = JS_NewObject(cx, &X3DMatrix3Class, NULL, NULL);
	if (!JS_SetPrivateFw(cx, retObj, anyret)) {
		printf("JS_SetPrivate failed in X3DMatrix3.inverse.\n");
		return JS_FALSE;
	}
	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(retObj));
	return JS_TRUE;
}


JSBool
X3DMatrix3multLeft(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	struct SFMatrix3d rhs;
	struct SFMatrix3d* cptr;
	struct SFMatrix3d* ret;
	JSObject* rhsObj = NULL;
	JSObject* retObj = NULL;

	AnyNative* anyret;
	if ((anyret = (AnyNative*)AnyNativeNew(FIELDTYPE_SFMatrix3d, NULL, NULL)) == NULL) {
		printf("SFMatrix3dNativeNew failed in X3DMatrix3.multLeft.\n");
		return JS_FALSE;
	}

	AnyNative* ptr;
	if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, obj)) == NULL) {
		printf("JS_GetPrivate failed in X3DMatrix3d.multLeft.\n");
		return JS_FALSE;
	}
	cptr = &ptr->v->sfmatrix3d;
	ret = &anyret->v->sfmatrix3d;
	matidentity3d(ret->c);
	matidentity3d(rhs.c);

	if (argc == 1) {
		if (!JS_ConvertArguments(cx, argc, argv, "o", &rhsObj)) {
			printf("JS_ConvertArgs failed in X3DMatrix3d.multLeft.\n");
			return JS_FALSE;
		}
		AnyNative* rhsptr;
		if ((rhsptr = (AnyNative*)JS_GetPrivateFw(cx, rhsObj)) == NULL) {
			printf("JS_GetPrivate failed in X3DMatrix3d.multLeft.\n");
			return JS_FALSE;
		}
		shallow_copy_field_precision(rhsptr->type, FIELDTYPE_SFMatrix3d, rhsptr->v, (union anyVrml*)&rhs);
	}
	matmultiply3d(ret->c, rhs.c, cptr->c);


	retObj = JS_NewObject(cx, &X3DMatrix3Class, NULL, NULL);
	if (!JS_SetPrivateFw(cx, retObj, anyret)) {
		printf("JS_SetPrivate failed in SFMatrix3dConstr.\n");
		return JS_FALSE;
	}
	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(retObj));
	return JS_TRUE;
}

JSBool
X3DMatrix3multRight(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	struct SFMatrix3d rhs;
	struct SFMatrix3d* cptr;
	struct SFMatrix3d* ret;
	JSObject* rhsObj = NULL;
	JSObject* retObj = NULL;

	AnyNative* anyret;
	if ((anyret = (AnyNative*)AnyNativeNew(FIELDTYPE_SFMatrix3d, NULL, NULL)) == NULL) {
		printf("SFMatrix3dNativeNew failed in X3DMatrix3.multLeft.\n");
		return JS_FALSE;
	}

	AnyNative* ptr;
	if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, obj)) == NULL) {
		printf("JS_GetPrivate failed in X3DMatrix3d.multLeft.\n");
		return JS_FALSE;
	}
	cptr = &ptr->v->sfmatrix3d;
	ret = &anyret->v->sfmatrix3d;
	matidentity3d(ret->c);
	matidentity3d(rhs.c);

	if (argc == 1) {
		if (!JS_ConvertArguments(cx, argc, argv, "o", &rhsObj)) {
			printf("JS_ConvertArgs failed in X3DMatrix3d.multLeft.\n");
			return JS_FALSE;
		}
		AnyNative* rhsptr;
		if ((rhsptr = (AnyNative*)JS_GetPrivateFw(cx, rhsObj)) == NULL) {
			printf("JS_GetPrivate failed in X3DMatrix3d.multLeft.\n");
			return JS_FALSE;
		}
		shallow_copy_field_precision(rhsptr->type, FIELDTYPE_SFMatrix3d, rhsptr->v, (union anyVrml*)&rhs);
	}
	matmultiply3d(ret->c, cptr->c, rhs.c);

	retObj = JS_NewObject(cx, &X3DMatrix3Class, NULL, NULL);
	if (!JS_SetPrivateFw(cx, retObj, anyret)) {
		printf("JS_SetPrivate failed in X3DMatrix3d.multLeft.\n");
		return JS_FALSE;
	}
	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(retObj));
	return JS_TRUE;
}


JSBool
X3DMatrix3multVecMatrix(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	struct SFVec2d rhs;
	struct SFMatrix3d* cptr;
	struct SFVec2d* ret;
	JSObject* rhsObj = NULL;
	JSObject* retObj = NULL;

	AnyNative* anyret;
	if ((anyret = (AnyNative*)AnyNativeNew(FIELDTYPE_SFVec2d, NULL, NULL)) == NULL) {
		printf("SFVec2dNativeNew failed in X3DMatrix3.multVecMatrix.\n");
		return JS_FALSE;
	}

	AnyNative* ptr;
	if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, obj)) == NULL) {
		printf("JS_GetPrivate failed in X3DMatrix3d.multVecMatrix.\n");
		return JS_FALSE;
	}
	cptr = &ptr->v->sfmatrix3d;
	ret = &anyret->v->sfvec2d;
	vecset2d(ret->c, 0.0, 0.0);
	vecset2d(rhs.c, 0.0, 0.0);

	if (argc == 1) {
		if (!JS_ConvertArguments(cx, argc, argv, "o", &rhsObj)) {
			printf("JS_ConvertArgs failed in X3DMatrix3d.multVecMatrix.\n");
			return JS_FALSE;
		}
		AnyNative* rhsptr;
		if ((rhsptr = (AnyNative*)JS_GetPrivateFw(cx, rhsObj)) == NULL) {
			printf("JS_GetPrivate failed in X3DMatrix3d.multVecMatrix.\n");
			return JS_FALSE;
		}
		shallow_copy_field_precision(rhsptr->type, FIELDTYPE_SFVec2d, rhsptr->v, (union anyVrml*)&rhs);
	}
	double a3[3], r3[3];
	veccopy2d(a3, rhs.c);
	a3[2] = 1.0;
	vecmultmat3d(r3, a3, cptr->c);
	if (r3[2] != 0.0) {
		double wi = 1.0 / r3[2];
		vecscale2d(ret->c, r3, wi);
	}
	else {
		veccopy2d(ret->c, r3);
	}

	retObj = JS_NewObject(cx, &SFVec2dClass, NULL, NULL);
	if (!JS_SetPrivateFw(cx, retObj, anyret)) {
		printf("JS_SetPrivate failed in X3DMatrix3d.multVecMatrix.\n");
		return JS_FALSE;
	}
	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(retObj));
	return JS_TRUE;
}


JSBool
X3DMatrix3multMatrixVec(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	struct SFVec2d rhs;
	struct SFMatrix3d* cptr;
	struct SFVec2d* ret;
	JSObject* rhsObj = NULL;
	JSObject* retObj = NULL;

	AnyNative* anyret;
	if ((anyret = (AnyNative*)AnyNativeNew(FIELDTYPE_SFVec2d, NULL, NULL)) == NULL) {
		printf("SFVec2dNativeNew failed in X3DMatrix3.multVecMatrix.\n");
		return JS_FALSE;
	}

	AnyNative* ptr;
	if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, obj)) == NULL) {
		printf("JS_GetPrivate failed in X3DMatrix3d.multVecMatrix.\n");
		return JS_FALSE;
	}
	cptr = &ptr->v->sfmatrix3d;
	ret = &anyret->v->sfvec2d;
	vecset2d(ret->c, 0.0, 0.0);
	vecset2d(rhs.c, 0.0, 0.0);

	if (argc == 1) {
		if (!JS_ConvertArguments(cx, argc, argv, "o", &rhsObj)) {
			printf("JS_ConvertArgs failed in X3DMatrix3d.multVecMatrix.\n");
			return JS_FALSE;
		}
		AnyNative* rhsptr;
		if ((rhsptr = (AnyNative*)JS_GetPrivateFw(cx, rhsObj)) == NULL) {
			printf("JS_GetPrivate failed in X3DMatrix3d.multVecMatrix.\n");
			return JS_FALSE;
		}
		shallow_copy_field_precision(rhsptr->type, FIELDTYPE_SFVec2d, rhsptr->v, (union anyVrml*)&rhs);
	}
	double a3[3], r3[3];
	veccopy2d(a3, rhs.c);
	a3[2] = 1.0f;
	matmultvec3d(r3, cptr->c, a3);
	if (r3[2] != 0.0f) {
		double wi = 1.0 / r3[2];
		vecscale2d(ret->c, r3, wi);
	}
	else {
		veccopy2d(ret->c, r3);
	}

	retObj = JS_NewObject(cx, &SFVec2dClass, NULL, NULL);
	if (!JS_SetPrivateFw(cx, retObj, anyret)) {
		printf("JS_SetPrivate failed in X3DMatrix3d.multVecMatrix.\n");
		return JS_FALSE;
	}
	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(retObj));
	return JS_TRUE;
}


JSBool
X3DMatrix3Assign(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_THIS_OBJECT(cx, vp);
	jsval* argv = JS_ARGV(cx, vp);
	jsval rval;
	if (!_standardMFAssign(cx, obj, argc, argv, &rval, &X3DMatrix3Class, FIELDTYPE_FreeWRLPTR/*does not matter*/)) { return JS_FALSE; }
	JS_SET_RVAL(cx, vp, rval);
	return JS_TRUE;
}


JSBool
X3DMatrix3Constr(JSContext* cx, uintN argc, jsval* vp) {
	JSObject* obj = JS_NewObject(cx, &X3DMatrix3Class, NULL, NULL);
	jsval* argv = JS_ARGV(cx, vp);
	jsdouble pars[9];
	double* cc;

	ADD_ROOT(cx, obj)
	AnyNative* any;
	if ((any = (AnyNative*)AnyNativeNew(FIELDTYPE_SFMatrix3d, NULL, NULL)) == NULL) {
		printf("SFMatrix3dNativeNew failed in X3DMatrix3Constr.\n");
		return JS_FALSE;
	}

	if (!JS_SetPrivateFw(cx, obj, any)) {
		printf("JS_SetPrivate failed in SFMatrix3dConstr.\n");
		return JS_FALSE;
	}
	cc = any->v->sfmatrix3d.c;

	matidentity3d(cc);

	int ncopy = 0;
	if (argc == 1) {
		JSObject* paramObj;
		int isArray;

		if (!JS_ValueToObject(cx, argv[0], &paramObj)) {
			printf("JS_ValueToObject failed in SFMatrix3dConstr.\n");
			return JS_FALSE;
		}

		if (JS_IsArrayObject(cx, paramObj)) {
			jsuint lengthp;
			jsval vp;
			double _d;
			//printf("its an array\n");
			isArray = TRUE;
			JS_GetArrayLength(cx, paramObj, &lengthp);
			ncopy = lengthp > 9 ? 9 : lengthp;
			for (int i = 0; i < ncopy; i++) {
				JS_GetElement(cx, paramObj, i, &vp);
				if (JS_ValueToNumber(cx, vp, &_d))
					cc[i] = _d;
			}
		}
		else {

			AnyNative* pptr;
			if ((pptr = (AnyNative*)JS_GetPrivateFw(cx, paramObj)) == NULL) {
				printf("JS_GetPrivate failed in X3DMatrix3Constr.\n");
				return JS_FALSE;
			}
			shallow_copy_field_precision(pptr->type, FIELDTYPE_SFMatrix3d, pptr->v, (union anyVrml*)cc);
		}
	}
	else if (argc == 9) {
		if (!JS_ConvertArguments(cx, argc, argv, "d d d d d d d d d",
			&(pars[0]), &(pars[1]), &(pars[2]), 
			&(pars[3]),	&(pars[4]), &(pars[5]), 
			&(pars[6]), &(pars[7]),	&(pars[8])
		))
		{
			printf("JS_ConvertArguments failed in X3DMatrix3Constr.\n");
			return JS_FALSE;
		}
		for (int i = 0; i < 9; i++)
			cc[i] = (double)pars[i];
	}
	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(obj));
	return JS_TRUE;
}

JSBool
X3DMatrix3AddProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid id = *hiid.address();
	jsval* vp = hvp.address();
	return doMFAddProperty(cx, obj, id, vp, "X3DMatrix3AddProperty");
}

JSBool
X3DMatrix3GetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid iid = *hiid.address();
	jsval* vp = hvp.address();
	int index;

	jsval id;
	if (!JS_IdToValue(cx, iid, &id)) {
		printf("JS_IdToValue failed in X3DMatrix3.GetProperty.\n");
		return JS_FALSE;
	}

	if (JSVAL_IS_INT(id)) {
		index = JSVAL_TO_INT(id);
		if (index > -1 && index < 3) {
			struct SFMatrix3d* cptr;

			AnyNative* ptr;
			if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, obj)) == NULL) {
				printf("JS_GetPrivate failed in X3DMatrix3d.multLeft.\n");
				return JS_FALSE;
			}
			cptr = &ptr->v->sfmatrix3d;
			double* row = &cptr->c[index * 3];

			AnyNative* anyret;
			if ((anyret = (AnyNative*)AnyNativeNew(FIELDTYPE_SFVec3d, NULL, NULL)) == NULL) {
				printf("SFVec4dNativeNew failed in X3DMatrix3.GetProperty.\n");
				return JS_FALSE;
			}
			anyret->gc = 0;
			anyret->type = FIELDTYPE_SFVec3d;
			anyret->v = (union anyVrml*)row;
			JSObject* retObj = JS_NewObject(cx, &SFVec3dClass, NULL, NULL);
			if (!JS_SetPrivateFw(cx, retObj, anyret)) {
				printf("JS_SetPrivate failed in SFMatrix3dConstr.\n");
				return JS_FALSE;
			}
			JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(retObj));
			return JS_TRUE;

		}
	}
	else if (id.isObject()) {
	}

	return JS_TRUE;
}

JSBool
X3DMatrix3SetProperty(JSContext* cx, JS::Handle<JSObject*> hobj, JS::Handle<jsid> hiid, JSBool strict, JS::MutableHandle<JS::Value> hvp) {
	JSObject* obj = *hobj.address();
	jsid iid = *hiid.address();
	jsval* vp = hvp.address();

	int index;

	jsval id;
	if (!JS_IdToValue(cx, iid, &id)) {
		printf("JS_IdToValue failed in X3DMatrix3.GetProperty.\n");
		return JS_FALSE;
	}

	if (JSVAL_IS_INT(id)) {
		index = JSVAL_TO_INT(id);
		if (index > -1 && index < 3) {
			struct SFMatrix3d* cptr;
			double rhs;
			if (!JS_ValueToNumber(cx, *vp, &rhs)) {
				printf("problems converting Javascript val to number in X3DMatrix.SetProperty\n");
				return JS_FALSE;
			}

			AnyNative* ptr;
			if ((ptr = (AnyNative*)JS_GetPrivateFw(cx, obj)) == NULL) {
				printf("JS_GetPrivate failed in X3DMatrix3d.multLeft.\n");
				return JS_FALSE;
			}
			cptr = &ptr->v->sfmatrix3d;
			double* row = &cptr->c[index * 3];
			row[index] = 100.0; //**** we don't set here. We set in SFVec3d [][]
			return JS_TRUE;

		}
	}
	else if (id.isObject()) {
	}

	return JS_TRUE;
}



#endif //defined(JS_SMCPP)

#endif //JAVASCRIPT_SM

